#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
  function<bool(int)> checkRight = [&](int i) {
    if(k == m - 1) {
      return false;
    }
    if(i < n - 1) {
      int j = k + 1, ok = 0;
      while(j < m && !blocked[i][j]) {
        if(!blocked[i + 1][j]) {
          ok = 1;
        }
        j++;
      }
      if(ok == 0) {
        return false;
      }
    }
    return investigate(k + 1);
  }; 
  function<bool(int)> checkLeft = [&](int i) {
    if(k == 0) {
      return false;
    }
    if(i < n - 1) {
      int j = k - 1, ok = 0;
      while(j >= 0 && !blocked[i][j]) {
        if(!blocked[i + 1][j]) {
          ok = 1;
        }
        j--;
      }
      if(ok == 0) {
        return false;
      }
    }
    return investigate(k - 1);
  };
  for(int i = 0; i < n; i++) {
    int answer = k;
    if(checkRight(i)) {
      // se duce in dreapta
      int dr = k + 1;
      while(dr < m - 1 && !blocked[i][dr + 1]) {
        dr++;
      }
      answer = k + 1;
      while(answer < dr && investigate(answer + 1)) {
        answer++;
      }
      // int st = k + 2;
      // answer = k + 1;
      // while(st <= dr) {
      //   int mij = (st + dr) / 2;
      //   if(investigate(mij)) {
      //     answer = mij;
      //     st = mij + 1;
      //   } else {
      //     dr = mij - 1;
      //   }
      // }
    } else if(checkLeft(i)) {
      // se duce in stanga
      int st = k - 1;
      while(st > 0 && !blocked[i][st - 1]) {
        st--;
      }
      answer = k - 1;
      while(answer > st && investigate(answer - 1)) {
        answer--;
      }
      // int dr = k - 2;
      // answer = k - 1;
      // while(st <= dr) {
      //   int mij = (st + dr) / 2;
      //   if(investigate(mij)) {
      //     answer = mij;
      //     dr = mij - 1;
      //   } else {
      //     st = mij + 1;
      //   }
      // }
    }
    goDeeper(answer);
    k = answer;
  }
}
