#include <iostream>
#include "tunnels.h"

using namespace std;

void solve( int n, int m, int k, const std::vector<std::vector<bool>>& b ){
  int x, st, dr, ss, sd;

  goDeeper( k );

  x = 1;
  while( x < n ){
    st = dr = k;
    ss = sd = 0;
    while( ss + sd == 0 ){
      if( st >= 0 ){
        ss = investigate( st );
        st--;
      }
      if( dr < m ){
        sd = investigate( dr );
        dr++;
      }
    }

    if( ss == 1 )
      goDeeper( st + 1 );
    else
      goDeeper( dr - 1 );
    x++;
  }
}
