#include <bits/stdc++.h>
using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}

std::ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

using ull = unsigned long long;
#define pb push_back

const int MAX_VAL = 1000000;

bool ciur[MAX_VAL + 1];
vector<int> primes;

int get_primes (__int128 n) {
  __int128 ans = 1;
  int idx = 0;

  while (ans * primes[idx] <= n) {
    ans *= primes[idx];
    idx++;
  }

  return idx;
}

signed main () {
    __int128 a, b, num;
    int d, i, till;

    for (d = 2; d <= MAX_VAL; d++) {
      if (ciur[d] == 0) {
        primes.push_back(d);
        for (i = 2 * d; i <= MAX_VAL; i += d) {
          ciur[i] = 1;
        }
      }
    }

    cin >> a >> b;

    till = get_primes(b);
    for (num = b; num >= a; num--) {
      i = 0;
      while (i < (till - 1)) {
        if (num % primes[i] != 0) {
          break;
        }
        i++;
      }
      if (i == till - 1) {
        cout << num;
        return 0;
      }
    }
    return 0;
}
