#include <bits/stdc++.h>
using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}

std::ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

using ull = unsigned long long;
#define pb push_back

const int MAX_VAL = 1000000;

bool ciur[MAX_VAL + 1];
vector<int> primes;

int get_num_divs (__int128 n) {
  int cnt = 0;
  for (__int128 d = 1; d * d <= n; d++) {
    if (n % d == 0) {
      cnt++;
      if (d != n / d) {
        cnt++;
      }
    }
  }
  return cnt;
}

signed main () {
    __int128 a, b, ans, candid;
    int idx, d, i, up_until, mx_divs, divs;
    bool change;

    for (d = 2; d <= MAX_VAL; d++) {
      if (ciur[d] == 0) {
        primes.push_back(d);
        for (i = 2 * d; i <= MAX_VAL; i += d) {
          ciur[i] = 1;
        }
      }
    }

    cin >> a >> b;

    ans = __int128(1);
    mx_divs = 0;
    for (up_until = 0; up_until < primes.size(); up_until++) {
      candid = __int128(1);
      while (true) {
        change = false;
        idx = 0;
        while (idx <= up_until && candid * primes[idx] <= b) {
          change = true;
          candid *= primes[idx];
          idx++;
        }
        if (!change) {
          break;
        }
      }
      if (a <= candid && candid <= b) {
        divs = get_num_divs(candid);
        if (divs > mx_divs) {
          mx_divs = divs;
          ans = candid;
        }
      }
    }

    cout << ans;
    return 0;
}
