#include <stdio.h>

#define MAXN 100000

struct node{
  long long c;
  int adj;
  int nrCon;
  long long steal;
};

struct vertex{
  int pointer;
  int next;
};

int nrE, maxnrCon;
struct node tree[MAXN+2];//padding
struct vertex edges[2*MAXN];


int chainMax, chainMaxPos, chainNeeded;
int chainParSum[MAXN+2];


static inline int abs(int a){
  return a > 0 ? a : -a;
}

static inline int myMax(int a, int b){
  return a > b ? a : b;
}

static inline void connect(int p, int c){
  edges[nrE].pointer = c;
  edges[nrE].next = tree[p].adj;
  tree[p].adj = nrE;

  tree[p].nrCon++;
  if(tree[p].nrCon > maxnrCon)
    maxnrCon = tree[p].nrCon;

  nrE++;
}

static inline void addEdge(int u, int v){
  connect(u, v);
  connect(v, u);
}

int main(){
  int n, m, a, b, i, sum, con, maxS, conCresc;

  scanf("%d%d", &n, &m);
  sum = 0;
  for(i = 1; i <= n; i++){
    scanf("%lld", &tree[i].c);
    sum += tree[i].c;
  }
  con = 1;
  nrE = 1;
  conCresc = 1;
  maxnrCon = 0;
  for(i = 1; i <= m; i++){
    scanf("%d%d", &a, &b);
    addEdge(a, b);
    if(abs(b-a) > 1)
      con = 0;
    else{
      if((b > a && tree[b].c < tree[a].c) || (a > b && tree[a].c < tree[b].c))
          conCresc = 0;
    }
  }



  return 0;
}

/*Testing

Chain:
5 4
-5 -3 -1 0 40
1 2
2 3
3 4
4 5

5 4
7 -1 20 -5 -7
1 2
2 3
3 4
4 5

Centre:

General:
7 6
-4 -3 6 0 4 -7 5
2 1
1 3
1 4
4 5
4 6
6 7

*/
