#include <stdio.h>
#include <vector>
#include "tunnels.h"

int l, c, dir;

void giveDir(std::vector<std::vector<bool>> blocked){
  if(c == 0 || (!blocked[l][c+1] && investigate(c+1)))
    dir = 1;
  else{
    dir = -1;
  }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
  if(m > 2){
    c = k;
    for(l = 0; l < n; l++){
      giveDir(blocked);
      while((c+dir) < n && (c+dir) >= 0 && !blocked[l][c+dir] && investigate(c+dir))
        c += dir;

      goDeeper(c);
    }
  }else{
    c = k;
    for(l = 0; l < n; l++){
      if(blocked[l+1][c])
        goDeeper(1-c);
    }
  }
}

/*
2 3 1
101
101
*/
