#include <stdio.h>
#include <vector>
#include "tunnels.h"

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
  int l, c, sum;

  for(l = 0; l < n; l++)
    for(c = 0; c < m; c++)
      if(blocked[l][c] == true)
        sum++;

  if(sum == 0){
    for(l = 0; l < n; l++)
      goDeeper(k);
  }else{
    if(m == 2){
      c = k;
      for(l = 0; l < n-1; l++){
        if(blocked[l+1][0] || blocked[l+1][1] || blocked[l][0] || blocked[l][1]){
          if(blocked[l+1][c])
            c = 1-c;
        }else{
          if(investigate(1-c))
            c = 1-c;
        }
        goDeeper(c);
      }
      goDeeper(c);
    }
  }
}

/*
1 1 0
0

5 2 1
0 0
1 0
1 0
0 0
0 0

2 3 1
000
000
*/
