#include "tunnels.h"

using namespace std;

vector<int> blockedremoved;

// How important is your tea party to not even give partial points if it takes ONE more query than necessary
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    //goDeeper(k);
    int nivel = 0, iepurstartpos = k, mostleft = k, mostright = k;
    while (nivel < n)
    {
        // find limits
        for (int i = iepurstartpos; i < m; i++)
        {
            if (blocked[nivel][i])
            {
                break;
            }
            else
            {
                mostright = i;
            }
        }
        for (int i = iepurstartpos; i >= 0; i--)
        {
            //cout << nivel << ":" << i << ":" << blocked[nivel][i] << "\n";
            if (blocked[nivel][i])
            {
                break;
            }
            else
            {
                mostleft = i;
            }
        }
        if (nivel < n-1)
        {
            while (blocked[nivel+1][mostleft])
            {
                mostleft++;
            }
            while (blocked[nivel+1][mostright])
            {
                mostright--;
            }
        }
        blockedremoved.clear();
        for (int i = mostleft; i <= mostright; i++)
        {
            if (nivel >= n-1)
                blockedremoved.push_back(i);
            else if (!blocked[nivel+1][i])
                blockedremoved.push_back(i);
        }
        int st = 0, dr = blockedremoved.size()-1, mij;
        while (st < dr)
        {
            mij = (st + dr) / 2;
            if (mij > iepurstartpos)
            {
                maimare:
                if (investigate(blockedremoved[mij]))
                {
                    st = mij;
                }
                else
                {
                    dr = mij-1;
                }
            }
            else if (mij < iepurstartpos)
            {
                if (investigate(blockedremoved[mij]))
                {
                    dr = mij;
                }
                else
                {
                    st = mij+1;
                }
            }
            else
            {
                mij++;
                goto maimare;
            }
        }
        nivel++;
        iepurstartpos = blockedremoved[st];
        goDeeper(blockedremoved[st]);
    }
    
}
