#include "tunnels.h"

using namespace std;

vector<int> blockedremoved;
vector<vector<int>> trulyblocked;

bool smartblocker[5005];

// How important is your tea party to not even give partial points if it takes ONE more query than necessary
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for (int i = 0; i < blocked.size(); i++)
    {
        trulyblocked.push_back({});
        for(int j = 0; j < blocked[i].size(); j++)
        {
            trulyblocked[i].push_back(blocked[i][j]);
        }
    }
    //goDeeper(k);
    for (int i = trulyblocked.size()-1; i >= 0; i--)
    {
        int slicestart = 0; bool slicenice = 0;
        for (int j = 0; j < trulyblocked[i].size(); j++)
        {
            
            if (trulyblocked[i][j])
            {
                smartblocker[j] = 1;
                slicestart = j+1;
                slicenice = 0;
            }
            else
            {
                if (!smartblocker[j])
                {
                    if (!slicenice)
                    {
                        for (int k = slicestart; k <= j; k++)
                            smartblocker[k] = 0;
                    }
                    slicenice = 1;
                }
                if (slicenice)
                    smartblocker[j] = 0;
            }
            if (smartblocker[j]) trulyblocked[i][j] = 1;
            //cout << trulyblocked[i][j];
        }
        //cout << "\n";
    }
    int nivel = 0, iepurstartpos = k, mostleft = k, mostright = k;
    while (nivel < n)
    {
        // find limits
        for (int i = iepurstartpos; i < m; i++)
        {
            if (trulyblocked[nivel][i])
            {
                break;
            }
            else
            {
                mostright = i;
            }
        }
        for (int i = iepurstartpos; i >= 0; i--)
        {
            //cout << nivel << ":" << i << ":" << trulyblocked[nivel][i] << "\n";
            if (trulyblocked[nivel][i])
            {
                break;
            }
            else
            {
                mostleft = i;
            }
        }
        if (nivel < n-1)
        {
            while (trulyblocked[nivel+1][mostleft])
            {
                mostleft++;
            }
            while (trulyblocked[nivel+1][mostright])
            {
                mostright--;
            }
        }
        blockedremoved.clear();
        for (int i = mostleft; i <= mostright; i++)
        {
            if (nivel >= n-1)
                blockedremoved.push_back(i);
            else if (!trulyblocked[nivel+1][i])
                blockedremoved.push_back(i);
        }
        int st = 0, dr = blockedremoved.size()-1, mij;
        while (st < dr)
        {
            mij = (st + dr) / 2;
            if (blockedremoved[mij] > iepurstartpos)
            {
                if ((st + dr) % 2) mij++;
                maimare:
                if (investigate(blockedremoved[mij]))
                {
                    st = mij;
                }
                else
                {
                    dr = mij-1;
                }
            }
            else if (blockedremoved[mij] < iepurstartpos)
            {
                if (investigate(blockedremoved[mij]))
                {
                    dr = mij;
                }
                else
                {
                    st = mij+1;
                }
            }
            else
            {
                mij++;
                goto maimare;
            }
        }
        nivel++;
        iepurstartpos = blockedremoved[st];
        goDeeper(blockedremoved[st]);
    }
    
}