#include<bits/stdc++.h>
//#define int __int128

using namespace std;

istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

const int nmax=1e6;

bitset <nmax+5> ciur;
vector <int> prime;

void eratostene()
{
    ciur[0]=ciur[1]=true;
    for (int i=2; i<=nmax; i++ )
        if ( !ciur[i] )
           for (int j=2*i; j<=nmax; j+=i )
               ciur[j]=true;

    for (int i=2; i<=nmax; i++ )
        if ( !ciur[i] )
            prime.push_back(i);
}

int nrd=1;

int desc(int x)
{
    nrd=1;
    for (auto d:prime )
    {
       if ( d*d>x )
            break;

       if ( x%d==0 )
       {
           int p=0;
           while ( x%d==0 )
           {
               p++;
               x/=d;
           }
           nrd=nrd*(p+1);
       }
    }

    if ( x>1 )
        nrd*=2;

    return nrd;
}

int v[nmax+5],t[4*nmax+5];

unordered_map <int,int> mp;

void update(int nod, int st, int dr, int poz, int val)
{
    if ( st==dr )
    {
        v[poz]=val;
        t[nod]=desc(val);
        mp[t[nod]]=val;

        return;
    }
    int mid=(st+dr)/2;

    if ( mid>=poz )
        update(2*nod,st,mid,poz,val);
    else update(2*nod+1,mid+1,dr,poz,val);

    t[nod]=max(desc(t[2*nod]),desc(t[2*nod+1]));
    mp[t[nod]]=val;
}

int query(int nod, int st, int dr, int p, int q)
{
    if ( st>=p && dr<=q )
        return mp[t[nod]];

    int mid=(st+dr)/2;
    int cl=INT_MIN, cr=INT_MIN;

    if ( mid>=p )
        cl=query(2*nod,st,mid,p,q);
    if ( mid+1<=q )
        cr=query(2*nod+1,mid+1,dr,p,q);

    return max(cl,cr);
}

signed main ()
{
    __int128 a,b;

    eratostene();
    cin >> a >> b;

    int maxi=INT_MIN,rez=0;

    int n;
    for (int i=a; i<=b; i++ )
        v[++n]=i;

    for (int i=1; i<=n; i++ )
        update(1,1,n,i,v[i]);

    cout << query(1,a,b,a,b);
    return 0;
}
