#include<bits/stdc++.h>
#define int __int128

using namespace std;

istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

const int nmax=99999;

bitset <nmax+5> ciur;
vector <int> prime;

void eratostene()
{
    ciur[0]=ciur[1]=true;
    for (int i=2; i<=nmax; i++ )
        if ( !ciur[i] )
           for (int j=2*i; j<=nmax; j+=i )
               ciur[j]=true;

    for (int i=2; i<=nmax; i++ )
        if ( !ciur[i] )
            prime.push_back(i);
}

int desc(int x)
{
    int nrd=1;
    for (auto d:prime )
    {
       if ( d*d>x )
            break;

       if ( x%d==0 )
       {
           int p=0;
           while ( x%d==0 )
           {
               p++;
               x/=d;
           }
           nrd=nrd*(p+1);
       }
    }

    if ( x>1 )
        nrd*=2;

    return nrd;
}

signed main ()
{
    __int128 a,b;

    eratostene();
    cin >> a >> b;

    int maxi=INT_MIN,rez=0;
    for (int i=a; i<=b; ++i )
    {
        if ( ciur[i]==false )
        {
            if ( 2>maxi )
            {
                maxi=2;
                rez=i;
            }

            continue;
        }

        if ( desc(i)>maxi )
        {
            maxi=desc(i);
            rez=i;
        }
    }

    cout << rez;
    return 0;
}
