#include<bits/stdc++.h>

using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n)
{
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num)
    {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
std::ostream& operator<< (std::ostream& out, __int128& n)
{
    std::string digs="";
    bool negative=false;
    if (n<0)
    {
        negative=true;
        n*=(-1);
    }
    for (;;)
    {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

__int128 a, b;

vector <int> ciur;

void eratostene ()
{
    ciur.resize(b-a+1);
    for (int i=0; i<=b-a; i++)
        ciur[i]=1;
    for (int i=1; i<=b-a; i++)
    {
        for (int j=i+a; j<=b; j+=i+a)
            ciur[j-a]++;
    }
}

int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> a >> b;
    eratostene();
    int rez=a;
    for (int i=1; i<=b-a; i++)
    {
        if (ciur[i]>ciur[rez-a])
            rez=i+a;
    }
    cout << rez;
    return 0;
}

