#include<bits/stdc++.h>

using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n)
{
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num)
    {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
std::ostream& operator<< (std::ostream& out, __int128& n)
{
    std::string digs="";
    bool negative=false;
    if (n<0)
    {
        negative=true;
        n*=(-1);
    }
    for (;;)
    {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

__int128 a, b;

unordered_map <__int128,int> v;
unordered_map <int,pair<int,__int128>> t;

void eratostene ()
{
    for (__int128 i=1; i<=b; i++)
        v[i]=1;
    for (__int128 i=2; i<=b; i++)
    {
        for (__int128 j=i; j<=b; j+=i)
            v[j]++;
    }
}

void init (__int128 nod, __int128 st, __int128 dr)
{
    if (st==dr)
        t[nod]={v[st],st};
    else
    {
        __int128 mij=(st+dr)/2;
        init(2*nod,st,mij);
        init(2*nod+1,mij+1,dr);
        t[nod]=max(t[2*nod],t[2*nod+1]);
    }
}

pair<int,__int128> query (__int128 nod, __int128 a, __int128 b, __int128 p, __int128 q)
{
    if (p<=a && b<=q)
        return t[nod];
    else
    {
        pair<int,__int128> cl={0,0}, cr={0,0};
        __int128 mij=(a+b)/2;
        if (mij>=p)
            cl=query(2*nod,a,mij,p,q);
        if (mij+1<=q)
            cr=query(2*nod+1,mij+1,b,p,q);
        return max(cl,cr);
    }
}

signed main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> a >> b;
    eratostene();
    init(1,1,b);
    pair<int,int> rez=query(1,1,b,a,b);
    cout << rez.second;
    return 0;
}
