#include <bits/stdc++.h>
using namespace std;
#define int long long
vector<vector<int>> gr;
vector<int> a, res;

pair<int, int> dfs(int u, int p) {
    int canSteal = 1'000'000'000;
    for (int v : gr[u]) {
        if (v != p) {
            auto [nd, cn] = dfs(v, u);
            a[u] -= nd;
            res[v] += cn;
            a[u] -= cn;
            a[v] += gr[v].size() * cn;
            canSteal = min(canSteal, a[v]);
        }
    }
    assert(canSteal >= 0);
    if (a[u] >= 0) {
        return {0, canSteal};
    }
    int ndt = (-a[u] + gr[u].size() - 1) / gr[u].size();
    if (canSteal * gr[u].size() < ndt) {
        cout << "Impossible\n";
        exit(0);
    }
    canSteal -= ndt;
    a[u] += ndt * gr[u].size();
    res[u] = ndt;
    return {ndt, canSteal};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }
    res.resize(n);
    dfs(0, -1);
    cout << "Possible\n";
    for (int i = 0; i < n; ++i) {
        cout << res[i] << " ";
    }
    cout << "\n";
}