#include "tunnels.h"
#include <bits/stdc++.h>
using namespace std;

void solve(int n, int m, int k, const vector<vector<bool>> &a) {
    vector<vector<bool>> used(n + 1, vector<bool>(m));
    deque<pair<int, int>> que;
    que.emplace_back(n, 0);
    used[n][0] = true;
    while (!que.empty()) {
        auto [i, j] = que.front();
        que.pop_front();
        if (j != 0) {
            if (!used[i][j - 1] && (i == n || !a[i][j - 1])) {
                que.emplace_back(i, j - 1);
                used[i][j - 1] = true;
            }
        }
        if (j != m - 1) {
            if (!used[i][j + 1] && (i == n || !a[i][j + 1])) {
                que.emplace_back(i, j + 1);
                used[i][j + 1] = true;
            }
        }
        if (i != 0) {
            if (!used[i - 1][j] && !a[i - 1][j]) {
                que.emplace_back(i - 1, j);
                used[i - 1][j] = true;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        vector<int> cn(m);
        for (int j = 0; j < m; ++j) {
            if (used[i + 1][j]) {
                cn[j] = 1;
            }
        }
        for (int j = k - 1; j >= 0; --j) {
            if (!used[i + 1][j] || !used[i][j]) {
                continue;
            }
            if (cn[j] == 1 || cn[j + 1] == 1) {
                cn[j] = 1;
            } else {
                cn[j] = 2;
            }
        }
        cn[k] = 2;
        for (int j = k + 1; j < m; ++j) {
            if (!used[i + 1][j] || !used[i][j]) {
                continue;
            }
            if (cn[j] == 1 || cn[j - 1] == 1) {
                cn[j] = 1;
            } else {
                cn[j] = 2;
            }
        }
        for (int j = k - 1; j >= 0; --j) {
            if (a[i][j]) {
                for (int j2 = j; j2 >= 0; --j2) {
                    cn[j2] = 0;
                }
                break;
            }
        }
        for (int j = k + 1; j < m; ++j) {
            if (a[i][j]) {
                for (int j2 = j; j2 < m; ++j2) {
                    cn[j2] = 0;
                }
                break;
            }
        }
        auto invest = [&](int j) {
            if (j < 0 || j >= m) {
                return false;
            } else if (cn[j] != 1) {
                return (cn[j] == 0 ? false : true);
            } else {
                bool ans = investigate(j);
                cn[j] = (ans ? 2 : 0);
                return ans;
            }
        };
        // for (int el : cn) {
        //     cout << el << " ";
        // }
        // cout << "\n";
        if (invest(k - 1)) {
            int L = -1, R = k;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (invest(M)) {
                    R = M;
                } else {
                    L = M;
                }
            }
            k = R;
            goDeeper(k);
        } else {
            int L = k, R = m;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (invest(M)) {
                    L = M;
                } else {
                    R = M;
                }
            }
            k = L;
            goDeeper(k);
        }
    }
}