#include "tunnels.h"
#include <bits/stdc++.h>
using namespace std;

void solve(int n, int m, int k, const vector<vector<bool>> &a) {
    vector<vector<bool>> used(n + 1, vector<bool>(m));
    deque<pair<int, int>> que;
    que.emplace_back(n, 0);
    used[n][0] = true;
    while (!que.empty()) {
        auto [i, j] = que.front();
        que.pop_front();
        if (j != 0) {
            if (!used[i][j - 1] && (i == n || !a[i][j - 1])) {
                que.emplace_back(i, j - 1);
                used[i][j - 1] = true;
            }
        }
        if (j != m - 1) {
            if (!used[i][j + 1] && (i == n || !a[i][j + 1])) {
                que.emplace_back(i, j + 1);
                used[i][j + 1] = true;
            }
        }
        if (i != 0) {
            if (!used[i - 1][j] && !a[i - 1][j]) {
                que.emplace_back(i - 1, j);
                used[i - 1][j] = true;
            }
        }
    }
    // for (auto ln : used) {
    //     for (auto cl : ln) {
    //         cout << cl << " ";
    //     }
    //     cout << "\n";
    // }
    for (int i = 0; i < n; ++i) {
        int stp = 0, enp = m - 1;
        for (int j = k - 1; j >= 0; --j) {
            if (a[i][j]) {
                stp = j + 1;
                break;
            }
        }
        for (int j = k + 1; j < m; ++j) {
            if (a[i][j]) {
                enp = j - 1;
                break;
            }
        }
        vector<int> cands;
        for (int j = stp; j <= enp; ++j) {
            if (used[i][j] && used[i + 1][j]) {
                cands.push_back(j);
            }
        }
        // for (int el : cn) {
        //     cout << el << " ";
        // }
        // cout << "\n";
        vector<int> csLessK, csGreK;
        for (int j : cands) {
            if (j < k) {
                csLessK.push_back(j);
            } else if (j > k) {
                csGreK.push_back(j);
            }
        }
        // cout << "------ level: " << i << " " << csLessK.size() << " " << csGreK.size() << "\n";
        int wherego = 10;
        bool needAddK = true;
        if (csGreK.empty()) {
            wherego = -1;
        }
        if (csLessK.empty()) {
            if (wherego == -1) {
                goDeeper(k);
                continue;
            }
            wherego = 1;
        }
        map<int, bool> mem;
        auto invest = [&](int j) {
            if (mem.count(j)) {
                return mem[j];
            }
            if (j < 0 || j >= m) {
                return false;
            }
            if (j == k) {
                return true;
            }
            return mem[j] = investigate(j);
        };
        if (wherego == 10) {
            if (invest(csGreK[0])) {
                wherego = 1;
                needAddK = false;
            } else {
                wherego = -1;
            }
        }
        if (wherego == -1) {
            if (used[i + 1][k]) {
                csLessK.push_back(k);
            }
            int l = -1, r = csLessK.size() - 1;
            while (r - l > 1) {
                int M = (l + r) / 2;
                if (invest(csLessK[M])) {
                    r = M;
                } else {
                    l = M;
                }
            }
            k = csLessK[r];
        } else {
            if (used[i + 1][k] && needAddK) {
                csGreK.insert(csGreK.begin(), k);
            }
            int l = 0, r = csGreK.size();
            while (r - l > 1) {
                int M = (l + r) / 2;
                if (invest(csGreK[M])) {
                    l = M;
                } else {
                    r = M;
                }
            }
            k = csGreK[l];
        }
        goDeeper(k);
    }
}