#include "tunnels.h"
#include <bits/stdc++.h>
using namespace std;
void solve(int n, int m, int k, const vector<vector<bool>> &a) {
    vector<vector<bool>> used(n + 1, vector<bool>(m));
    deque<pair<int, int>> que;
    que.emplace_back(n, 0);
    used[n][0] = true;
    while (!que.empty()) {
        auto [i, j] = que.front();
        que.pop_front();
        if (j != 0) {
            if (!used[i][j - 1] && (i == n || !a[i][j - 1])) {
                que.emplace_back(i, j - 1);
                used[i][j - 1] = true;
            }
        }
        if (j != m - 1) {
            if (!used[i][j + 1] && (i == n || !a[i][j + 1])) {
                que.emplace_back(i, j + 1);
                used[i][j + 1] = true;
            }
        }
        if (i != 0) {
            if (!used[i - 1][j] && !a[i - 1][j]) {
                que.emplace_back(i - 1, j);
                used[i - 1][j] = true;
            }
        }
    }
    for (auto ln : used) {
        for (auto cl : ln) {
            cout << cl << " ";
        }
        cout << "\n";
    }
    for (int i = 0; i < n; ++i) {
        int stp = 0, enp = m - 1;
        for (int j = k - 1; j >= 0; --j) {
            if (a[i][j]) {
                stp = j + 1;
                break;
            }
        }
        for (int j = k + 1; j < m; ++j) {
            if (a[i][j]) {
                enp = j - 1;
                break;
            }
        }
        vector<int> cands;
        for (int j = stp; j <= enp; ++j) {
            if (used[i][j] && used[i + 1][j]) {
                cands.push_back(j);
            }
        }
        // for (int el : cn) {
        //     cout << el << " ";
        // }
        // cout << "\n";
        // cout << "------ level: " << i << " " << csLessK.size() << " " << csGreK.size() << "\n";
        map<int, bool> mem;
        int ops = 0;
        auto invest = [&](int j) {
            if (mem.count(j)) {
                return mem[j];
            }
            if (j < 0 || j >= m) {
                return false;
            }
            if (j == k) {
                return true;
            }
            ops++;
            return mem[j] = investigate(j);
        };
        auto getNewLR = [&](int l, int r, int x, bool ans) {
            if (cands[x] < k) {
                if (ans) {
                    r = x;
                } else {
                    l = x;
                }
            } else if (cands[x] > k) {
                if (ans) {
                    l = x - 1;
                } else {
                    r = x - 1;
                }
            }
            return make_pair(l, r);
        };
        int l = -1, r = cands.size() - 1;
        while (r - l > 1) {
            int M = -1, worst = 1'000'000'000;
            for (int i = l + 1; i <= r; ++i) {
                auto pr1 = getNewLR(l, r, i, false), pr2 = getNewLR(l, r, i, true);
                int cur = max(pr1.second - pr1.first, pr2.second - pr2.first);
                if (cur < worst) {
                    M = i;
                    worst = cur;
                }
            }
            assert(cands[M] != k);
            if (cands[M] == k) {
                if (M >= cands.size() - M - 1) {
                    M--;
                } else {
                    M++;
                }
            }
            auto [newL, newR] = getNewLR(l, r, M, invest(cands[M]));
            l = newL;
            r = newR;
        }
        // L impossible, R possible
        k = cands[r];
        assert(ops == __lg(cands.size() * 2 - 1));
        goDeeper(k);
    }
}