#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<ll> ve = {1,2,4,6,12,24,36,48,60,120,180,240,360,720,840,1260,1680,2520,5040,7560,10080,15120,20160,25200,27720,45360,50400,55440,83160,110880,166320,221760,277200,332640,498960,554400,665280,720720,1081080,1441440,2162160,2882880,3603600,4324320,6486480,7207200, 8648640,10810800, 14414400, 17297280,21621600,32432400,36756720,43243200,61261200,73513440,110270160,122522400,147026880,183783600, 245044800,294053760,367567200};

vector<__int128> a;
vector<vector<ll>> g;
vector<__int128> need;
vector<__int128> ans;

void dfs1(ll u, ll p = -1) {
    __int128 ma = -1e18;
    for (auto v : g[u]) {
        if (p != v) {
            dfs1(v, u);
            ma = max(ma, a[v]);
        }
    }
    if (ma >= 0) {
        ans[u] += ma;
        if (p != -1) {
            a[p] -= ma;
            a[u] += ma;
        }
        for (auto v : g[u]) {
            if (p != v) {
                a[v] -= ma;
                a[u] += ma;
            }
        }
    }
}

void dfs3(ll u, ll p = -1) {
    need[u] = __int128(-a[u]);
    for (auto v : g[u]) {
        if (p != v) {
            dfs3(v, u);
            need[u] += need[v];
        }
    }
}

void ge(ll u, ll cnt, ll p) {
    ans[u] += cnt;
    for (auto v : g[u]) {
        if (v != p) {
            need[v] += __int128(cnt);
        }
        a[v] -= cnt;
        a[u] += cnt;
    }
}

void dfs2(ll u, ll p = -1) {
    for (auto v : g[u]) {
        if (p != v) {
            if (need[v] > 0) {
                ge(v, need[v], u);
            }
            dfs2(v, u);
        }
    }
}

signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll n, m;
    cin >> n >> m;
    ans.resize(n);
    g.resize(n);
    a.resize(n);
    __int128 su = 0;
    for (ll i = 0; i < n; i++) {
        ll x;
        cin >> x;
        a[i] = __int128(x);
        su += a[i];
    }
    if (su < 0) {
        cout << "Impossible" << endl;
        return 0;
    }
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    need.assign(n, 0);
    dfs1(0);
    dfs3(0);
    dfs2(0);
    cout << "Possible" << endl;
    __int128 v = ans[0];
    for (auto u : ans) {
        v = min(v, u);
    }
    for (auto u : ans) {
        if (u >= __int128(1e18)) {
            return 1;
        }
        cout << ll(u - v) << " ";
    }
}