#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<iomanip>
#include<functional>
#include<numeric>
#include "tunnels.h"

using namespace std;


#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmax(a, b) a = max(a, b)
#define chmin(a, b) a = min(a, b)

void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
	int tk = k;
	for (int i = 0; i < n; ++i) {
		bool isl = 0, f = 0, f1 = 0;
		if (tk == 0) isl = 0;
		else if (tk == m - 1) isl = 1;
		else {
			if (tk >= m / 2) {
				isl = investigate(tk - 1);
				if (isl) f = 1;
			}
			else {
				isl = !investigate(tk + 1);
				if (!isl) f1 = 1;
			}
			
		}
		if (isl) {
			int l = tk - f;
			int r = -1;
			while (r + 1 < l) {
				int m = (l + r + 1) / 2;
				bool res = investigate(m);
				if (res) l = m;
				else r = m;
			}
			goDeeper(l);
			tk = l;
		}
		else {
			int l = tk + f;
			int r = m;
			while (l + 1 < r) {
				int m = (l + r) / 2;
				bool res = investigate(m);
				if (res) l = m;
				else r = m;
			}
			goDeeper(l);
			tk = l;
		}
	}
}

/*void solve() {
	int n, m, k; cin >> n >> m >> k;

}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//precalc();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
*/