#include<iostream>
#include<algorithm>
#include<string>


using namespace std;

istream& operator>> (istream& inp, __int128& n) {
    string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
ostream& operator<< (ostream& out, __int128 n) {
    string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

vector<__int128> prime;
__int128 best_cnt = -1, best = -1;

void rec(__int128 ind, __int128 mx, __int128 now, __int128 cnt, __int128 cnt_pr) {
    if (ind == prime.size()) {
        if (cnt > best_cnt) {
            best_cnt = cnt;
            best = now;
        }
        return;
    }
    //cout << ind << " " << now << endl;
    __int128 cnt_now = 0;
    while (now <= mx) {
        rec(ind + 1, mx, now, cnt * (cnt_now + 1), cnt_now);
        if (cnt_now == cnt_pr) {
            break;
        }
        now *= prime[ind];
        cnt_now++;
    }
}

int get(__int128 b) {
    __int128 now = 1, i = 2, cnt = 0;
    while (now * i <= b) {
        bool is_prime = true;
        for (__int128 j = 2; j * j <= i; j++) {
            if (i % j == 0) {
                is_prime = false;
                break;
            }
        }
        if (is_prime) {
            prime.push_back(i);
            now *= i;
        }
        i++;
    }
    if (cnt == 0) {
        cnt++;
        //cout << i << endl;
    }
    rec(0, b, 1, 1, 1e18);
    return best;
}

__int128 getdiv(__int128 j) {
    __int128 cnt = 0;
    for (__int128 a = 1; a * a <= j; a++) {
        if (j % a == 0) {
            cnt += 2;
            if (a * a == j) {
                cnt--;
            }
        }
    }
    return cnt;
}

__int128 get_slow(__int128 b) {
    __int128 best_cnt = -1, best = -1;
    for (__int128 j = 1; j <= b; j++) {
        __int128 cnt = getdiv(j);
        if (best_cnt < cnt) {
            best_cnt = cnt;
            best = j;
        }
    }
    return best;
}

int main() {
    __int128 j;
    cin >> j >> j;
    cout << get(j) << endl;
    // for (__int128 j = 1; j <= 10000; j++) {
    //     if (getdiv(get_slow(j)) != getdiv(get(j))) {
    //         cout << j << endl;
    //         cout << get_slow(j) << endl;
    //         cout << get(j) << endl;
    //         //36 = 2 * 2 * 3 * 3
    //         cout << getdiv(get_slow(j)) << " " << getdiv(get(j)) << endl;
    //         return 0;
    //     }
    // }
}
