#include<iostream>
#include<algorithm>
#include<string>


using namespace std;

istream& operator>> (istream& inp, __int128& n) {
    string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
ostream& operator<< (ostream& out, __int128 n) {
    string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

vector<__int128> prime;
__int128 best_cnt = -1, best = -1;

void rec(__int128 ind, __int128 mx, __int128 now, __int128 cnt, __int128 cnt_pr) {
    if (ind == prime.size()) {
        if (cnt > best_cnt) {
            best_cnt = cnt;
            best = now;
        }
        return;
    }
    if (ind >= 6) {
        if (now <= mx / prime[ind] && cnt_pr != 0) {
            rec(ind + 1, mx, now * prime[ind], cnt * 2, 1);
        } else {
            rec(ind + 1, mx, now, cnt, 0);
        }
        return;
    }
    //cout << ind << " " << now << endl;
    __int128 cnt_now = 0;
    while (now <= mx) {
        rec(ind + 1, mx, now, cnt * (cnt_now + 1), cnt_now);
        if (cnt_now == cnt_pr) {
            break;
        }
        if (now <= mx / prime[ind]) {
            now *= prime[ind];
            cnt_now++;
        } else {
            break;
        }
    }
}

__int128 get(__int128 b) {
    __int128 now = 1, i = 2, cnt = 0;
    while (now <= b / i) {
        bool is_prime = true;
        for (__int128 j = 2; j * j <= i; j++) {
            if (i % j == 0) {
                is_prime = false;
                break;
            }
        }
        if (is_prime) {
            prime.push_back(i);
            now *= i;
        }
        i++;
    }
    if (cnt == 0) {
        cnt++;
        //cout << i << endl;
    }
    rec(0, b, 1, 1, 1e18);
    return best;
}

void getdiv(__int128 j) {
    for (auto &a : prime) {
        long long cnt = 0;
        while (j % a == 0) {
            j /= a;
            cnt++;
        }
        cout << a << " " << cnt << endl;
    }
    //cout << j << " " << 1 << endl;
}


int main() {
    __int128 j, c = 0;
    cin >> j >> j;
    vector<string> all = {
"1083865676362735631477014163124864000",
"1056769034453667240690088809046742400",
"812899257272051723607760622343648000",
"704512689635778160460059206031161600",
"677416047726709769673133851953040000",
"541932838181367815738507081562432000",
"406449628636025861803880311171824000",
"352256344817889080230029603015580800",
"270966419090683907869253540781216000",
"258649763677471002966105652563888000",
"241271469053348685089061371928480000",
"203224814318012930901940155585912000",
"193017175242678948071249097542784000",
"162579851454410344721552124468729600",
"144762881432009211053436823157088000",
"135483209545341953934626770390608000",
"133627275168008502510864759837312000",
"120635734526674342544530685964240000",
"108386567636273563147701416312486400",
"96508587621339474035624548771392000",
"81289925727205172360776062234364800",
"72381440716004605526718411578544000",
"67741604772670976967313385195304000"};
    for (auto &i : all) {
        __int128 c = 0;
        for (auto &k : i) {
            c = c * 10 + (k - '0');
        }
        if (c <= j) {
            cout << c << endl;
            return 0;
        }
    }
    cout << get(j) << endl;
    return 0;
    //1219348885908077585411640933515472000
    auto ans = j;
    while (ans != 0) {
        //cout << ans << " " << ans - 1 << " " << get(ans - 1) << endl;
        best = -1;
        best_cnt = -1;
        prime.clear();
        ans = get(ans - 1);
        cout << ans << endl;
    }
    //getdiv(ans);
    // for (__int128 j = 1; j <= 10000; j++) {
    //     if (getdiv(get_slow(j)) != getdiv(get(j))) {
    //         cout << j << endl;
    //         cout << get_slow(j) << endl;
    //         cout << get(j) << endl;
    //         //36 = 2 * 2 * 3 * 3
    //         cout << getdiv(get_slow(j)) << " " << getdiv(get(j)) << endl;
    //         return 0;
    //     }
    // }
}
