#include<iostream>
#include<vector>

using namespace std;

vector<vector<long long>> g;
vector<long long> a, cnt, ans;
long long add = 0;
void dfs(long long v, long long p) {
	cnt[v] = a[v];
	for (auto &i : g[v]) {
		if (i == p) {
			continue;
		}
		dfs(i, v);
		cnt[v] += cnt[i];
	}
}

void all_up(long long v, long long p) {
	for (auto &i : g[v]) {
		if (i == p) {
			continue;
		}
		all_up(i, v);
		if (a[i] < 0) {
			ans[i] += -a[i];
		} else {
			ans[i] -= a[i];
			add += a[i];
		}
		a[v] += a[i];
	}
}

void count(long long v, long long p) {
	for (auto &i : g[v]) {
		if (i == p) {
			continue;
		}
		ans[i] += ans[v];
		count(i, v);
	}
}

int main() {
	long long n, m;
	cin >> n >> m;
	a.resize(n);
	cnt.resize(n);
	g.resize(n);
	ans.resize(n);
	for (auto &i : a) {
		cin >> i;
	}
	vector<long long> pr = a;
	while (m--) {
		long long u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0, -1);
	if (cnt[0] < 0) {
		cout << "Impossible" << endl;
		return 0;
	}
	all_up(0, -1);
	count(0, -1);
	for (auto &i : ans) {
		i += add;
	}
	a = pr;
	for (long long v = 0; v < n; v++) {
		a[v] += ans[v] * g[v].size();
		for (auto &i : g[v]) {
			a[v] -= ans[i];
		}
		if (a[v] < 0) {
			cout << "Impossible" << endl;
			return 0;
		}
	}
	cout << "Possible" << endl;
	for (auto &i : ans) {
		cout << i << " ";
	}
	cout << endl;
}