#pragma once

#include <vector>

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
	for (int i = 0; i < n; i++) {
		bool left = false, right = false;
		if (k - 1 >= 0 && !blocked[i][k - 1]) {
			left = investigate(k - 1);
		}
		if (k + 1 < m && !blocked[i][k + 1]) {
			right = investigate(k + 1);
		}
		if (!left && !right) {
			goDeeper(k);
			continue;
		}
		if (left) {
			k++;
			for (long long i = 12; i >= 0; i--) {
				if (k - (1 << i) >= 0 && investigate(k - (1 << i))) {
					k -= (1 << i);
				}
			}
			goDeeper(k);
			continue;
		}
		if (right) {
			for (long long i = 12; i >= 0; i--) {
				if (k + (1 << i) >= 0 && investigate(k + (1 << i))) {
					k += (1 << i);
				}
			}
			goDeeper(k);
			continue;
		}
	}
}

void goDeeper(int s);
bool investigate(int s);
