#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
	for (int i = 0; i < n; i++) {
		bool left = false, right = false;
		if (k - 1 >= 0 && !blocked[i][k - 1] && (i + 1 == n || !blocked[i + 1][k + 1])) {
			left = investigate(k - 1);
		}
		if (k + 1 < m && !blocked[i][k + 1] && (i + 1 == n || !blocked[i + 1][k + 1])) {
			right = investigate(k + 1);
		}
		if (!left && !right) {
			goDeeper(k);
			continue;
		}
		int l = k, r = k;
		for (long long j = k; j < n; j++) {
			if (blocked[i][j]) {
				break;
			}
			if (i + 1 != n && !blocked[i][j]) {
				r = j;
			}
		}
		for (long long j = k; j >= 0; j--) {
			if (blocked[i][j]) {
				break;
			}
			if (i + 1 != n && !blocked[i][j]) {
				l = j;
			}
		}
		if (left) {
			k++;
			for (long long i = 12; i >= 0; i--) {
				if (k - (1 << i) >= l && investigate(k - (1 << i))) {
					k -= (1 << i);
				}
			}
			goDeeper(k);
			continue;
		}
		if (right) {
			for (long long i = 12; i >= 0; i--) {
				if (k + (1 << i) <= r && investigate(k + (1 << i))) {
					k += (1 << i);
				}
			}
			goDeeper(k);
			continue;
		}
	}
}
