#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
	for (int i = 0; i < n; i++) {
		int l = k, r = k;
		for (long long j = k; j < n; j++) {
			if (blocked[i][j]) {
				break;
			}
			if (i + 1 == n || !blocked[i + 1][j]) {
				r = j;
			}
		}
		for (long long j = k; j >= 0; j--) {
			if (blocked[i][j]) {
				break;
			}
			if (i + 1 == n || !blocked[i + 1][j]) {
				l = j;
			}
		}
		bool left = false, right = false;
		if (l != k) {
			left = investigate(k - 1);
		}
		if (r != k) {
			right = investigate(k + 1);
		}
		if (!left && !right) {
			goDeeper(k);
			continue;
		}
		if (left) {
			k++;
			for (long long j = 12; j >= 0; j--) {
				if (k - (1 << j) >= l && investigate(k - (1 << j))) {
					k -= (1 << j);
				}
			}
			goDeeper(k);
			continue;
		}
		if (right) {
			for (long long j = 12; j >= 0; j--) {
				if (k + (1 << j) <= r && investigate(k + (1 << j))) {
					k += (1 << j);
				}
			}
			goDeeper(k);
			continue;
		}
	}
}
