#pragma once

#include <vector>

void goDeeper(int s);
bool investigate(int s);

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    for (int i = 0; i < n; i++) {
        int l = k, r = k;
        std::vector<int> good_r, good_l;
        for (long long j = k; j < m; j++) {
            if (blocked[i][j]) {
                break;
            }
            if (i + 1 == n || !blocked[i + 1][j]) {
                r = j;
                good_r.push_back(j);
            }
        }
        for (long long j = k; j >= 0; j--) {
            if (blocked[i][j]) {
                break;
            }
            if (i + 1 == n || !blocked[i + 1][j]) {
                l = j;
                good_l.push_back(j);
            }
        }
        bool left = false, right = false, k_1 = false;
        if (l != k && r != k) {
            left = investigate(k - 1);
            k_1 = left;
            right = !left;
            //right = investigate(k + 1);
        } else if (l != k) {
            left = true; 
        } else if (r != k) {
            right = true;
        }
        if (!left && !right) {
            goDeeper(k);
            continue;
        }
        if (left) {
            long long ind = 0;
            for (long long j = 12; j >= 0; j--) {
                if (ind + (1 << j) < good_l.size() && (k_1 || investigate(good_l[ind + (1 << j)]))) {
                    ind += (1 << j);
                }
            }
            k = good_l[ind];
            goDeeper(good_l[ind]);
            continue;
        }
        if (right) {
            long long ind = 0;
            for (long long j = 12; j >= 0; j--) {
                if (ind + (1 << j) < good_r.size() && investigate(good_r[ind + (1 << j)])) {
                    ind += (1 << j);
                }
            }
            k = good_r[ind];
            goDeeper(good_r[ind]);
            continue;
        }
    }
}