#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define int __int128
std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
std::ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}
vector <int> muchii[100005], v[100005];
int neces[100005], tata[100005], val[100005], f[100005], w[100005];
void build( int x ){
    int i, y;
    f[x] = 1;
    for( i = 0; i < muchii[x].size(); i++ ){
        y = muchii[x][i];
        if( f[y] == 0 ){
            v[x].push_back( y );
            tata[y] = x;
            build( y );
        }
    }
}
void gather( int x ){
    int i, max_val, y;
    max_val = 0;
    for( i = 0; i < v[x].size(); i++ ){
        y = v[x][i];
        gather( y );
        max_val = max( val[y], max_val );
        ///cout << x << ' ' << y << ' ' << val[y] << '\n';
    }
    w[x] += max_val;
    ///cout << "IESIT " << x << ' ' << w[x] << ' ' << max_val << '\n';
    for( i = 0; i < v[x].size(); i++ ){
        y = v[x][i];
        if( val[y] < 0 ){
            neces[y] += max_val;
            val[y] -= max_val;
        }
        else{
            val[y] -= max_val;
            neces[y] += -val[y];
        }
        neces[x] += neces[y];
    }
    y = tata[x];
    if( y != 0 ){
        val[y] -= max_val;
        val[x] += max_val;
    }
    val[x] += ( v[x].size() ) * max_val;
    if( val[x] < 0 ){
        neces[x] += -val[x];
    }
    ///cout << x << ' ' << max_val << ' ' << neces[x] << '\n';
}
void distribute( int x ){
    int i, y;
    w[x] += neces[x];
    for( i = 0; i < v[x].size(); i++ ){
        y = v[x][i];
        val[y] -= neces[x];
        neces[y] += neces[x];
        distribute( y );
    }
}
int32_t main(){
    int n, m, i, x, y, tot;
    ios::sync_with_stdio( false );
    cin.tie( 0 );
    cout.tie( 0 );
    cin >> n >> m;
    tot = 0;
    for( i = 1; i <= n; i++ ){
        cin >> val[i];
        tot += val[i];
    }
    if( tot < 0 ){
        cout << "Impossible";
        return 0;
    }
    for( i = 0; i < m; i++ ){
        cin >> x >> y;
        muchii[x].push_back( y );
        muchii[y].push_back( x );
    }
    build( 1 );
    ///cout << '\n';
    /**for( i = 1; i <= n; i++ ){
        cout << w[i] << ' ';
    }
    cout << '\n';*/
    gather( 1 );
    /**for( i = 1; i <= n; i++ ){
        cout << w[i] << ' ';
    }
    cout << '\n';
    for( i = 1; i <= n; i++ ){
        cout << val[i] << ' ';
    }
    cout << '\n';
    for( i = 1; i <= n; i++ ){
        cout << neces[i] << ' ';
    }
    cout << '\n';*/
    for( i = 0; i < v[1].size(); i++ ){
        distribute( v[1][i] );
    }
    cout << "Possible" << '\n';
    for( i = 1; i <= n; i++ ){
        cout << w[i] << ' ';
    }
    return 0;
}
