#include <iostream>
#include <vector>
bool investigate( int s );
void goDeeper( int s );
///#include "tunnels.h"
using namespace std;
void solve( int n, int m, int k, const std::vector<std::vector<bool>> &blocked ){
    #define int long long
    int i, st, dr, mij, a, b;
    for( i = 0; i < n; i++ ){
        /**st = k;
        while( st > 0 && blocked[i][st - 1] == 0 ){
            st--;
        }
        dr = k;
        while( dr < m - 1 && blocked[i][dr + 1] == 0 ){
            dr++;
        }
        if( k > 0 && blocked[i][k - 1] == 0 && investigate( k - 1 ) == true ){
            k = cauta( 0, k - 1 );
            continue;
        }
        if( k < m - 1 && blocked[i][k + 1] == 0 && investigate(  ) )*/
        if( k > 0 && investigate( k - 1 ) == true ){
            st = -1;
            dr = k - 1;
            while( dr - st > 1 ){
                mij = ( st + dr ) / 2;
                if( investigate( mij ) == 0 ){
                    st = mij;
                }
                else{
                    dr = mij;
                }
            }
            goDeeper( dr );
            k = dr;
            continue;
        }
        if( k < m - 1 && investigate( k + 1 ) == true ){
            st = k + 1;
            dr = m;
            while( dr - st > 1 ){
                mij = ( st + dr ) / 2;
                if( investigate( mij ) == 0 ){
                    dr = mij;
                }
                else{
                    st = mij;
                }
            }
            goDeeper( st );
            k = st;
            continue;
        }
        goDeeper( k );
        /**a = k;
        b = ( k + 1 ) % 2;
        if( blocked[i][a] == 1 || ( i < n - 1 && blocked[i + 1][a] == 1 ) ){
            goDeeper( b );
            k = b;
            continue;
        }
        if( blocked[i][b] == 1 || ( i < n - 1 && blocked[i + 1][b] == 1 ) ){
            goDeeper( a );
            k = a;
            continue;
        }
        if( investigate( b ) == true ){
            goDeeper( b );
            k = b;
            continue;
        }
        goDeeper( a );
        k = a;*/
    }
}

static int n, m, k;
static std::vector<std::vector<bool>> blocked;
static void input(){
    std::cin >> n >> m >> k;
    blocked.resize(n);
    for (int i = 0; i < n; i++){
        blocked[i].resize(m);
        for (int j = 0; j < m; j++){
            char c;
            std::cin >> c;
            blocked[i][j] = c == '1';
        }
    }
}
static int numQueries = 0;
static int currX;
static int currY;
static void goTo(int y){
    std::cout << "On level " << currX << " going from " << currY << " to " << y << std::endl;
    while (currY != y){
        if (currY < y) currY++;
        else currY--;
        if (blocked[currX][currY]){
            std::cout << "Passing through blocked chamber." << std::endl;
            exit(0);
        }
    }
}
bool investigate(int y){
    numQueries++;
    std::cout << "Investigating: " << y << std::endl;
    goTo(y);
    std::cout << "Enter 0/1:" << std::endl;
    bool ans;
    std::cin >> ans;
    return ans;
}
void goDeeper(int y){
    std::cout << "Going deeper: " << y << std::endl;
    if (currX == n){
        std::cout << "Already in the treasure room." << std::endl;
        exit(0);
    }
    goTo(y);
    currX++;
    if (currX == n) return;

    if (blocked[currX][currY]){
        std::cout << "Went deeper into a blocked chamber." << std::endl;
        exit(0);
    }
}
int main(){
    input();
    currX = 0;
    currY = k;
    if (blocked[currX][currY]){
        std::cout << "Starting chamber is blocked." << std::endl;
        exit(0);
    }
    solve(n, m, k, blocked);
    if (currX < n){
        std::cout << "Did not reach the treasure room." << std::endl;
        exit(0);
    }
    std::cout << "Reached the treasure room." << std::endl;
    std::cout << "Number of investigations: " << numQueries << std::endl;
    return 0;
}
