#include <stdio.h>
#include <numeric>

using ll = long long;
const int BULAN = 35;

ll lcm[BULAN + 1];

int main() {
  ll a, b;
  scanf("%lld%lld", &a, &b);

  lcm[0] = 1;
  for(int i = 1; i <= BULAN; i++) {
    lcm[i] = std::lcm(lcm[i - 1], i);
  }

  int st = 0;
  int dr = BULAN;
  while(dr - st > 1) {
    int mij = (st + dr) / 2;
    if(lcm[mij] >= a) {
      dr = mij;
    } else {
      st = mij;
    }
  }

  ll x = lcm[dr];
  if(x <= b) {
    printf("%lld\n", x);
  } else {
    x = lcm[dr - 1];
    while(x < a) {
      x *= 2;
    }
    printf("%lld\n", x);
  }

  return 0;
}