#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;
int prv[5001][5001];
int nxt[5001][5001];
int nr[5001];
char inv[5001];
bool getInv(int k){
  if(inv[k] != -1)
    return inv[k];
  return (inv[k] = investigate(k));
}
void solve(int n, int m, int k, const vector<vector<bool>>& blocked){
  for( int i = 0; i < n; i++ ) {
    for( int j = 0; j < m; j++ ) {
      if(i != n - 1 && !blocked[i][j] && !blocked[i + 1][j])
        nr[i]++;
      else if(i == n - 1 && !blocked[i][j])
        nr[i]++;

    }
    prv[i][0] = blocked[i][0] ? 0 : -1;
    for( int j = 1; j < m; j++ ) {
      if( blocked[i][j] ) {
        prv[i][j] = j;
      }else
        prv[i][j] = prv[i][j - 1];

    }
    nxt[i][m - 1] = blocked[i][m - 1] ? m - 1 : m;
    for( int j = m - 2; j >= 0; j-- ) {
      if( blocked[i][j] ) {
        nxt[i][j] = j;
      }else
        nxt[i][j] = nxt[i][j + 1];
    }
  }
  if(m == 1) {
    for( int i = 1; i <= n; i++ )
      goDeeper(k);
    return;
  }
  for( int i = 0; i < n; i++ ) {
    if(nr[i] == 1){
      goDeeper(k);
      continue;
    }
    for( int j = 0; j < m; j++ )
      inv[j] = -1;
    if(k == m - 1) {
      if(getInv(k - 1)) {
        int st = prv[i][k] + 1;
        int dr = k - 1;
        while(dr - st > 1) {
          int mij = (st + dr) / 2;
          if(!getInv(mij)){
            dr = mij;
          }else
            st = mij;
        }
        goDeeper(st);
        k = st;
      }
      else{
        goDeeper(k);
      }
    }
    else if(k == 0) {
      if(getInv(k + 1)) {
        int st = k;
        int dr = nxt[i][st];
        while(dr - st > 1) {
          int mij = (st + dr) / 2;
          if(!getInv(mij)){
            dr = mij;
          }else
            st = mij;
        }
        goDeeper(st);
        k = st;
      } else {
        goDeeper(k);
      }
    }
    else if(getInv(k + 1)) {
      int st = k;
      int dr = nxt[i][st];
      while(dr - st > 1) {
        int mij = (st + dr) / 2;
        if(!getInv(mij)){
          dr = mij;
        }else
          st = mij;
      }
      goDeeper(st);
      k = st;
    } else if(getInv(k - 1)){
      int st = prv[i][k] + 1;
      int dr = k - 1;
      while(dr - st > 1) {
        int mij = (st + dr) / 2;
        if(!getInv(mij)){
          dr = mij;
        }else
          st = mij;
      }
      goDeeper(st);
      k = st;
    } else{
      goDeeper(k);
    }
  }
}
