#include <iostream>
#include <vector>
#include "tunnels.h"
using namespace std;
void solve(int n, int m, int k, const vector<vector<bool>>& blocked) {
    goDeeper(k);
    int s = k;
    for(int i = 1; i < n; i++) {
        for(int j = s-1; j >= 0; j--) {
            if(blocked[i][j]) break;
            if(investigate(j)) {
                s = j;
                goDeeper(j);
                break;
            }
        }
        for(int j = s+1; j < m; j++) {
            if(blocked[i][j]) break;
            if(investigate(j)) {
                s = j;
                goDeeper(j);
                break;
            }
        }
    }
}