#include <bits/stdc++.h>
using namespace std;

#include<iostream>
#include<algorithm>
#include<string>
std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
std::ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}









const int MAXN = 5e5 + 10;
__int128 segment[4 * MAXN + 10];

__int128 query(int idx, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) return LLONG_MAX;
    if (ql <= l && r <= qr) return segment[idx];

    int m = (l + r) / 2;
    return min(query(2 * idx, l, m, ql, qr), query(2 * idx + 1, m + 1, r, ql, qr));
}

__int128 update(int idx, int l, int r, int pos, __int128 val) {
    if (pos < l || r < pos) return segment[idx];
    if (l == r) return segment[idx] = min(segment[idx], val);

    int m = (l + r) / 2;
    return segment[idx] = min(update(2 * idx, l, m, pos, val), update(2 * idx + 1, m + 1, r, pos, val));
}

vector <__int128> primes{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37};

int compute_divisors(__int128 n) {
    int ans = 1;

    for (int x : primes) {
        if (n == 1) break;

        int cnt = 1;

        while (n % x == 0) {
            n /= x;
            cnt++;
        }

        ans *= cnt;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (int i = 1; i <= 4 * MAXN; i++) {
        segment[i] = LLONG_MAX;
    }

    __int128 useless, bound;
    cin >> useless >> bound;

    vector <pair <__int128, int>> numbers{{1, 1}}; /// {num, divisors}

    for (int p : primes) {
        update(1, 1, MAXN, compute_divisors(numbers.back().first * p), numbers.back().first * p);
    }

    while (numbers.back().first <= bound) {
        __int128 num = query(1, 1, MAXN, numbers.back().second + 1, MAXN);
        //cout << num << endl;

        numbers.push_back({num, compute_divisors(num)});

        for (int p : primes) {
            update(1, 1, MAXN, compute_divisors(numbers.back().first * p), numbers.back().first * p);
            //cout << "Added: " << numbers.back().first * p << endl;

        }
    }

    while (numbers.back().first > bound) {
        numbers.pop_back();
    }

    cout << numbers.back().first << endl;
    return 0;

}
