#include <bits/stdc++.h>

using namespace std;
const long long MAXN = 200000;
const long long INF = 1e9;
long long v[MAXN + 1];
long long nrv[MAXN + 1], par[MAXN + 1];
long long rez[MAXN + 1], nrm[MAXN + 1];
vector<long long> adj[MAXN + 1];
void dfs(long long nod) {
    long long nr, i, x;
    long long maxr;
    nr = adj[nod].size();
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        if (par[x] < 0) {
            par[x] = nod;
            dfs(x);
        }
    }
    //iau maximul dintre vecini
    maxr = 0;
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        if (v[x] > maxr) {
            maxr = v[x];
        }
    }
    v[nod] += maxr * nr;
    rez[nod] += maxr;
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        v[x] -= maxr;
    }
}
void dfs2(long long nod) {
    long long nr, i, x;
    nr = adj[nod].size();
    if (v[nod] < 0) {
        nrm[nod] -= v[nod];//cate - sunt in subarbore
    }
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        if (par[x] == nod) {
            dfs2(x);
            nrm[nod] += nrm[x];
        }
    }
}
void dfs3(long long nod) {
    long long nr, i, x, y, nr2, j;
    nr = adj[nod].size();
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        if (par[x] == nod) {
            rez[x] += nrm[x];
            nr2 = adj[x].size();
            v[x] += (long long)nr2 * nrm[x];
            for (j = 0; j < nr2; j++) {
                y = adj[x][j];
                v[y] -= nrm[x];
                if (v[y] < 0) {
                    nrm[y] += nrm[x];
                }
            }
            //scad si la fii lui x
            dfs3(x);
        }
    }
}
int main()
{
    long long n, m, i, x2, y, ver, j;
    long long s, x;
    scanf("%lld%lld", &n, &m);
    s = 0;
    for (i = 1; i <= n; i++) {
        scanf("%lld", &v[i]);
        s += v[i];
        par[i] = -1;
    }
    for (i = 0; i < m; i++) {
        scanf("%lld%lld", &x2, &y);
        adj[x2].push_back(y);
        adj[y].push_back(x2);
        nrv[x2]++;
        nrv[y]++;
    }
    //arbore
    if (s < 0) {
        printf("Impossible\n");
    } else {
        printf("Possible\n");
        par[1] = 0;
        dfs(1);
        dfs2(1);
        dfs3(1);//acum fiecare fiu ia cat sa il fac pe parinte 0
        for (i = 1; i <= n; i++) {
            printf("%lld ", rez[i]);
        }
    }
    /*fputc('\n', stdout);
    for (i = 1; i <= n; i++) {
        printf("%lld ", v[i]);
    }*/
    return 0;
}
