#include <bits/stdc++.h>

using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
std::ostream& operator<< (std::ostream& out, __int128 n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

// obs 1: nu iti pasa de a, vrei doar sa afli maximul pana la b

// ceva backtracking cu ceva destept la final - nush exact cat o sa ia

int prime[] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97};

__int128 a, b;
long long maxnrdiv = 0;
vector<vector<int>> sols;
vector<int> sol;

void bkt(__int128 prod, long long nrdiv) {
  if(nrdiv > maxnrdiv) {
    maxnrdiv = nrdiv;
    sols = {sol};
  } else if(nrdiv == maxnrdiv) {
    sols.push_back(sol);
  }
  sol.push_back(0);
  while(prod * prime[(int)sol.size() - 1] <= b) {
    prod *= prime[(int)sol.size() - 1];
    sol.back()++;
    if((int)sol.size() >= 2 && sol[(int)sol.size() - 1] > sol[(int)sol.size() - 2]) {
      break;
    }
    bkt(prod, nrdiv * (sol.back() + 1));
  }
  sol.pop_back();
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  cin >> a >> b;
  bkt(1, 1);

  // lowkey nu cred ca intra in timp dar merita incercat
  __int128 answer = 0;
  for(int i = 0; i < (int)sols.size(); i++) {
    // cout << "Suntem la solutia " << i << ":\n";
    // for(int j = 0; j < (int)sols[i].size(); j++) {
      // cout << sols[i][j] << " ";
    // }
    // cout << "\n";

    __int128 nr = 1;
    int ult = 0;
    for(int j = 0; j < (int)sols[i].size(); j++) {
      // cout << "Exponentul " << j << " este " << sols[i][j] << "\n";
      for(int x = ult; x + (int)sols[i].size() - j <= 24; x++) {
        // cout << "Incercam sa avem " << prime[x] << "\n";
        __int128 nrnou = nr;
        // cout << "Initial nr = " << nr << "\n";
        for(int y = x; y < x + (int)sols[i].size() - j; y++) {
          // cout << "Vom aduga nr prim " << prime[y] << "\n";
          for(int z = 0; z < sols[i][j + y - x]; z++) {
            nrnou *= prime[y];
            if(nrnou > b) {
              break;
            }
          }
          if(nrnou > b) {
            break;
          }
        }
        if(nrnou > b) {
          // cout << "Nu reusim pentru ca raspunsul e " << nrnou << "\n";
          break;
        }
        // cout << "Reusim si raspunsul e " << nrnou << "\n";
        ult = x + 1;
      }
      for(int z = 0; z < sols[i][j]; z++) {
        nr *= prime[ult - 1];
      }
    }
    // cout << "=> " << nr << "\n";
    if(nr > answer) {
      answer = nr;
    }
  }

  cout << answer << "\n";
  return 0;
}