#include <bits/stdc++.h>
#define in cin
#define out cout
#define mkp make_pair

using namespace std;
using ll = long long;

ll c[100001], c1[100001];
vector<ll> v[100001];
ll add[100001];

void solve(int nod, int f){
    for(const int & cop : v[nod]){
        if(cop == f) continue;
        solve(cop, nod);
    }

    ll mini = 0;
    for(const int & cop : v[nod]){
        if(cop == f) continue;
        mini = c[ cop ];
    }
    ll nev = max(0LL, mini);
    //cout << "nod = " << nod << " nev = " << nev << " c[nod] = " << c[nod] << '\n';

    add[nod] = nev;
    c[nod] += nev * v[nod].size();
    for(const int & cop : v[nod]){
        c[cop] -= nev;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(NULL);

    int n, m; in >> n >> m;
    bool cresc = 1;
    for(int i = 0; i < n; i++){
        in >> c[i];
        if(i > 0 && c[i] < c[i - 1]) cresc = 0;
        c1[i] = c[i];
    }
    for(int i = 0; i < m; i++){
        int a, b; in >> a >> b;
        a--, b--;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    int root = -1;
    for(int i = 0; i < n; i++){
        if(v[i].size() > 1) root = i;
    }

    ll mx = 0;
    for(int i = 0; i < n; i++){
        if(i != root) mx = max(mx, c[i]);
    }
    add[root] = mx;
    c[root] += mx * (n - 1);
    for(int i = 0; i < n; i++){
        if(i != root){
            c[i] -= mx;
            add[i] = -c[i];
            c[root] -= add[i];
        }
    }

    if(c[root] < 0) out << "Impossible\n";
    else{
        out << "Possible\n";
        for(int i = 0; i < n; i++) cout << add[i] << " ";
    }
    return 0;
}
