#include <iostream>
#include "tunnels.h"

using namespace std;

void solve( int n, int m, int k, const std::vector<std::vector<bool>>& b ){
  int x, st, dr, ss, sd, cam;

  goDeeper( k );

  x = 1;
  cam = k;
  while( x < n ){
    st = dr = cam;
    ss = sd = 0;
    while( ss + sd == 0 ){
      if( st >= 0 ){
        ss = investigate( st );
        st--;
      }
      if( dr < m ){
        sd = investigate( dr );
        dr++;
      }
    }

    if( ss == 1 )
      cam = st + 1;
    else
      cam = dr - 1;
    goDeeper( cam );
    x++;
  }
}
