#include "tunnels.h"
#include <iostream>
#include <vector>
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    int i,poz,gasit,st,dr,j,rasp,mij;
    int stb[n+1][m+1],drb[n+1][m+1];
    for(i=0;i<n;i++){
        stb[i][0]=blocked[i][0];
        for(j=1;j<m;j++){
            if(blocked[i][j]) stb[i][j]=j;
            else stb[i][j]=stb[i][j-1];
        }
        drb[i][m-1]=m-blocked[i][m-1];
        for(j=m-2;j>=0;j--){
            if(blocked[i][j]) drb[i][j]=j;
            else drb[i][j]=drb[i][j+1];
        }
    }
    for(i=0;i<n;i++){
        if(k+1<m && !blocked[i][k+1] && investigate(k+1)){
            st=rasp=k+1;dr=drb[i][k+1]-1;
            while(st<=dr){
                mij=(st+dr)/2;
                if(investigate(mij)){
                    rasp=mij;st=mij+1;
                }else dr=mij-1;
            }
            k=rasp;
            goDeeper(k);
        }else{
            st=stb[i][k-1]+1;dr=rasp=k;
            while(st<=dr){
                mij=(st+dr)/2;
                if(investigate(mij)){
                    rasp=mij;dr=mij-1;
                }else st=mij+1;
            }
            k=rasp;
            goDeeper(k);
        }
    }
}
