#include "tunnels.h"
#include <iostream>
#include <vector>
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
    int i,poz,gasit,st,dr,j,rasp,mij;
    int stb[n+1][m+1],drb[n+1][m+1];
    for(i=0;i<n;i++){
        stb[i][0]=blocked[i][0];
        for(j=1;j<m;j++){
            if(blocked[i][j]) stb[i][j]=j;
            else stb[i][j]=stb[i][j-1];
        }
        drb[i][m-1]=m-blocked[i][m-1];
        for(j=m-2;j>=0;j--){
            if(blocked[i][j]) drb[i][j]=j;
            else drb[i][j]=drb[i][j+1];
        }
    }
    for(i=0;i<n;i++){
        if(i<n-1 && blocked[i+1][k]) gooDeeper(1-k);
        else if(!blocked[i][1-k] && (i==n-1 || blocked[i+1][1-k]==0) && investigate(1-k)){
            goDeeper(1-k);
        }else goDeeper(k);
    }
}
