#include <stdio.h>
#include <vector>
#include "tunnels.h"

int l, c, dir, sum;

void giveDir(std::vector<std::vector<bool>> blocked){
  if(c == 0 || (!blocked[l][c+1] && investigate(c+1)))
    dir = 1;
  else{
    dir = -1;
  }
}

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
  if(m > 2){
    sum = 0;
    for(l = 0; l < n; l++)
      for(c = 0; c < m; c++)
        if(blocked[l][c] == true)
          sum++;

    if(sum == 0){
      for(l = 0; l < n; l++)
        goDeeper(k);
    }else{
      c = k;
      for(l = 0; l < n; l++){
        giveDir(blocked);
        while((c+dir) < n && (c+dir) >= 0 && !blocked[l][c+dir] && investigate(c+dir))
          c += dir;

        goDeeper(c);
      }
    }
  }else{
    c = k;
    for(l = 0; l < n-1; l++){
      if(blocked[l+1][c]){
        goDeeper(1-c);
        c = 1-c;
      }else
        goDeeper(c);
    }
    goDeeper(c);
  }
}

/*
5 2 0
0 1
0 0
1 0
0 0
1 0
*/
