#include <stdio.h>
#include <vector>
#include "tunnels.h"

int l, c, dir, sum;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked){
  for(l = 0; l < n; l++)
    for(c = 0; c < m; c++)
      if(blocked[l][c] == true)
        sum++;

  if(sum == 0){
      for(l = 0; l < n; l++)
        goDeeper(k);
  }else{
    c = k;
    for(l = 0; l < n-1; l++){
      if(blocked[l+1][c])
        c = 1-c;
      goDeeper(c);
    }
    goDeeper(c);
  }
}

/*
1 1 0
0

5 2 1
0 0
1 0
1 0
0 0
0 1

2 3 1
000
000
*/
