#include "tunnels.h"

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    //goDeeper(k);
    int nivel = 0, iepurstartpos = k, mostleft = k, mostright = k;
    while (nivel < n)
    {
        // find limits
        for (int i = iepurstartpos; i < m; i++)
        {
            if (blocked[nivel][i])
            {
                break;
            }
            else
            {
                mostright = i;
            }
        }
        for (int i = iepurstartpos; i >= 0; i--)
        {
            //cout << nivel << ":" << i << ":" << blocked[nivel][i] << "\n";
            if (blocked[nivel][i])
            {
                break;
            }
            else
            {
                mostleft = i;
            }
        }
        //cout << mostleft << ":" << mostright << "\n";
        bool direction;
        if (mostright == iepurstartpos)
            direction = 0;
        else if (mostleft == iepurstartpos)
            direction = 1;
        else
        {
            direction = investigate(iepurstartpos+1);
        }
        if (direction == 0)
        {
            int st = mostleft, dr = iepurstartpos, mij;
            while (st < dr)
            {
                mij = (st+dr)/2;
                if (investigate(mij))
                {
                    dr = mij;
                }
                else
                {
                    st = mij+1;
                }
            }
            nivel++;
            iepurstartpos = st;
            goDeeper(st);
        }
        else
        {
            int st = iepurstartpos, dr = mostright, mij;
            while (st < dr)
            {
                mij = (st+dr)/2+(st+dr)%2;
                if (investigate(mij))
                {
                    st = mij;
                }
                else
                {
                    dr = mij-1;
                }
            }
            nivel++;
            iepurstartpos = st;
            goDeeper(st);
        }
    }
    
}