#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax=1e5;

vector <int> g[nmax+5];
int grad[nmax+5],n,m;

int val[nmax+5],times[nmax+5];

bool viz[nmax+5];
vector <int> order;

bool cycle;

void brut()
{
    while ( true )
    {
        bool ok=true;

        for (int i=1; i<=n; i++ )
            if ( val[i]<0 )
            {
                ok=false;
                break;
            }

        if ( ok==true )
        {
            cout << "Possible" << '\n';
            for (int i=1; i<=n; i++ )
                cout << times[i] << " ";
            exit(0);
        }

        for (int i=1; i<=n; i++ )
        {
            if ( val[i]<0 )
            {
                while ( val[i]<0 )
                {
                    val[i]+=grad[i];
                    times[i]++;

                    for (auto vec:g[i] )
                        val[vec]--;
                }
            }
        }
    }
}

bool chain()
{
    if ( grad[1]!=1 )
        return false;

    if ( grad[n]!=1 )
        return false;

    for (int i=2; i<n; i++ )
        if ( grad[i]!=2 )
            return false;

    return true;
}

void subtask1()
{

    int sum=0;

    for (int i=1; i<=n; i++ )
        sum+=val[i];

    if ( sum<0 )
    {
        cout << "Impossible";
        exit(0);
    }

    brut();
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int sum=0;
    cin >> n >> m;
    for (int i=1; i<=n; i++ )
        cin >> val[i];

    for (int i=1; i<=m; i++ )
    {
        int x,y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);

        grad[x]++;
        grad[y]++;
    }

    if ( chain()==true )
    {
        bool s1=true;
        for (int i=1; i<n; i++ )
            if ( val[i]>val[i+1] )
            {
                s1=false;
                break;
            }

        //if ( s1==true )
            subtask1();
    }

    brut();
    return 0;
}
