#include "tunnels.h"
#include <bits/stdc++.h>

using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& b) {
  int c = k;
  for (int i = 0; i < n; i++) {
    int bl = -1, br = m;
    vector<int> vl, vr;
    for (int j = c - 1; j >= 0; j--) {
      if (b[i][j]) {
        bl = c;
        break;
      } else if (i == n - 1 or !b[i + 1][j]) {
        vl.push_back(j);
      }
    }
    for (int j = c + 1; j < m; j++) {
      if (b[i][j]) {
        br = c;
        break;
      } else if (i == n - 1 or !b[i + 1][j]) {
        vr.push_back(j);
      }
    }
    /*cout << i << " " << vl.size() << " " << vr.size() << "\n";
    for (int x : vl)
      cout << x << " ";
    cout << "\n";
    for (int x : vr)
      cout << x << " ";
    cout << "\n";*/
    int l, r, M;
    if (vl.size() == 0 and vr.size() == 0) {
      goDeeper(c);
      continue;
    }
    if (vr.size() == 0 or (vl.size() != 0 and investigate(vl[0]))) {
      l = 0;
      r = vl.size();
      M = (l + r) / 2;
      while (l + 1 < r) {
        if (investigate(vl[M]))
          l = M;
        else
          r = M;
        M = (l + r) / 2;
      }
      c = vl[l];
    } else {
      l = -1;
      r = vr.size();
      M = (l + r) / 2;
      while (l + 1 < r) {
        if (investigate(vr[M]))
          l = M;
        else
          r = M;
        M = (l + r) / 2;
      }
      if (l != -1)
        c = vr[l];
    }
    goDeeper(c);
  }
}