#include <bits/stdc++.h>
using namespace std;
using vl = __int128;
using ll = long long;
using pii = pair<ll, ll>;
const ll MAXN = 1e6;
const ll MAXC = 300;

vector<ll> s, pr;
void prep() {
    s.assign(MAXN, 0);
    iota(s.begin(), s.end(), 0);
    for (ll i = 2; i < MAXN; i++) {
        if (s[i] != i) continue;
        if ((ll)pr.size() < MAXC) {
            pr.push_back(i);
        }
        for (ll j = i * i; j < MAXN; j += i) {
            s[j] = min(s[j], i);
        }
    }
}

ll c_d(ll x) {
    ll r = 1;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i) continue;
        ll c = 1;
        while (x % i == 0) {
            x /= i;
            c++;
        }
        r *= c;
    }
    if (x > 1) r *= 2;
    return r;
}

void g_d(ll x) {
    ll r = 1;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i) continue;
        ll c = 1;
        while (x % i == 0) {
            x /= i;
            c++;
        }
        cout << i << ": " << c - 1 << '\n';
    }
    if (x > 1) {
        cout << x << ": " << 1 << '\n';
    }
}


void solve() {
    ll l, r;
    cin >> l >> r;

    ll rr = 1;
    for (ll ns = 1; ns < MAXN; ns++) {
        vector<ll> dl;
        ll x = ns;
        while (x > 1) {
            ll pr = s[x];
            dl.push_back(0);
            while (x % pr == 0) {
                dl.back()++;
                x /= pr;
            }
        }
        sort(dl.rbegin(), dl.rend());

        ll i = 0;
        vl pp = 1;
        bool fl = 1;
        for (auto &j : dl) {
            if (!fl) break;
            for (ll _ = 0; _ < j; _++) {
                pp *= pr[i];
                if (pp > r) {
                    fl = 0;
                    break;
                }
            }
            i++;
        }
        if (fl) {
            rr = (ll)pp;
            if (pp == 0) {
                ll gg;
                gg++;
            }
        }
    }

    cout << rr << '\n';
}


int main() {
    prep();
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}