#include <bits/stdc++.h>
using namespace std;
using vl = __int128;
using ll = long long;
using pii = pair<ll, ll>;
const ll MAXN = 1e3;
const ll MAXC = 20;
const ll INF = 1e18 + 10;

vector<ll> s, pr;
void prep() {
    s.assign(MAXN, 0);
    iota(s.begin(), s.end(), 0);
    for (ll i = 2; i < MAXN; i++) {
        if (s[i] != i) continue;
        if ((ll)pr.size() < MAXC) {
            pr.push_back(i);
        }
        for (ll j = i * i; j < MAXN; j += i) {
            s[j] = min(s[j], i);
        }
    }
}

ll c_d(ll x) {
    ll r = 1;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i) continue;
        ll c = 1;
        while (x % i == 0) {
            x /= i;
            c++;
        }
        r *= c;
    }
    if (x > 1) r *= 2;
    return r;
}

void g_d(ll x) {
    ll r = 1;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i) continue;
        ll c = 1;
        while (x % i == 0) {
            x /= i;
            c++;
        }
        cout << i << ": " << c - 1 << '\n';
    }
    if (x > 1) {
        cout << x << ": " << 1 << '\n';
    }
}


void solve() {
    ll l, r;
    cin >> l >> r;
    vector<ll> vv = {2, 3, 5, 7, 11, 13, 17, 19, 23};
    vector<ll> oth = {29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71};

    pii ans = {1, 1};
    vector<pii> cr = {{1, 1}};
    for (auto &el : vv) {
        ll crr = 1;
        ll cn = 0;
        while (crr < r) {
            crr *= el;
            cn++;
        }

        vector<pii> nw;
        for (auto &[x, cc] : cr) {
            ll add = 1;
            for (ll _ = 1; _ < cn; _++) {
                add *= el;
                if (x * add <= r) {
                    ans = max(ans, {cc * (_ + 1), x * add});
                    nw.push_back({x * add, cc * (_ + 1)});
                }
            }
        }
        sort(nw.begin(), nw.end());
        cr.clear();
        ll pmx = 0;
        for (ll i = 0; i < (ll)nw.size(); i++) {
            if (pmx >= nw[i].second) continue;
            cr.push_back(nw[i]);
            pmx = nw[i].second;
        }
    }
    for (auto &el : oth) {
        if (ans.second * el <= r) {
            ans.second *= el;
        } else {
            break;
        }
    }

    cout << ans.second << '\n';
}


int main() {
    prep();
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}