#include <bits/stdc++.h>
using namespace std;
using vl = __int128;
using ll = long long;
using pii = pair<ll, ll>;
const ll MAXN = 1e3;
const ll MAXC = 20;
const ll INF = 1e18 + 10;

vector<ll> s, pr;
void prep() {
    s.assign(MAXN, 0);
    iota(s.begin(), s.end(), 0);
    for (ll i = 2; i < MAXN; i++) {
        if (s[i] != i) continue;
        if ((ll)pr.size() < MAXC) {
            pr.push_back(i);
        }
        for (ll j = i * i; j < MAXN; j += i) {
            s[j] = min(s[j], i);
        }
    }
}

ll c_d(ll x) {
    ll r = 1;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i) continue;
        ll c = 1;
        while (x % i == 0) {
            x /= i;
            c++;
        }
        r *= c;
    }
    if (x > 1) r *= 2;
    return r;
}

void g_d(ll x) {
    ll r = 1;
    for (ll i = 2; i * i <= x; i++) {
        if (x % i) continue;
        ll c = 1;
        while (x % i == 0) {
            x /= i;
            c++;
        }
        cout << i << ": " << c - 1 << '\n';
    }
    if (x > 1) {
        cout << x << ": " << 1 << '\n';
    }
}

struct Int {
    vector<ll> r;

    bool operator < (const Int &o) const {
        if (r.size() != o.r.size()) {
            return (r.size() < o.r.size());
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] < o.r[i];
            }
        }
        return false;
    }

    bool operator <= (const Int &o) const {
        if (r.size() != o.r.size()) {
            return (r.size() < o.r.size());
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] < o.r[i];
            }
        }
        return true;
    }

    Int operator * (const Int &o) const {
        ll sz1 = r.size();
        ll sz2 = o.r.size();
        vector<ll> rs(sz1 + sz2);
        for (ll i = 0; i < sz1; i++) {
            for (ll j = 0; j < sz2; j++) {
                rs[i + j] += (r[i] * o.r[j]);
            }
        }

        ll cr = 0;
        for (auto &el : rs) {
            ll f = (el + cr);
            el = f % 10;
            cr = f / 10;
        }
        while (rs.back() == 0) {
            rs.pop_back();
        }

        return Int(rs);
    }

    Int(string s) {
        ll sz = s.size();
        reverse(s.begin(), s.end());
        r.assign(sz, 0);
        for (ll i = 0; i < sz; i++) {
            r[i] = (s[i] - '0');
        }
    }

    Int(ll x) {
        r = {};
        while (x > 0) {
            r.push_back(x % 10);
            x /= 10;
        }
    }

    Int(vector<ll> _r) {
        r = _r;
    }
    Int() {}
};


void solve() {
    Int l, r;
    string l1, rr;
    cin >> l1 >> rr;
    l = Int(l1); r = Int(rr);
    vector<ll> vv = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41};
    vector<ll> oth = {43, 47, 53, 59, 61, 67, 71};

    pair<vl, Int> ans = {1, Int("1")};
    vector<pair<Int, vl>> cr = {{Int("1"), 1}};
    for (auto &el : vv) {
        Int crr = Int("1");
        vl cn = 0;
        while (crr < r) {
            crr = (crr * Int(el));
            cn++;
        }

        vector<pair<Int, vl>> nw;
        for (auto &[x, cc] : cr) {
            Int add = 1;
            for (ll _ = 1; _ < cn; _++) {
                add = (add * el);
                if ((Int(x) * add) <= r) {
                    ans = max(ans, {cc * (_ + 1), (Int(x) * add)});
                    nw.push_back({(Int(x) * add), cc * (_ + 1)});
                }
            }
        }
        sort(nw.begin(), nw.end());
        cr.clear();
        ll pmx = 0;
        for (ll i = 0; i < (ll)nw.size(); i++) {
            if (nw[i].second <= pmx) continue;
            cr.push_back(nw[i]);
            pmx = nw[i].second;
        }
    }

    for (auto &el : oth) {
        if ((ans.second * Int(el)) <= r) {
            ans.second = (ans.second * Int(el));
        }
    }

    reverse(ans.second.r.begin(), ans.second.r.end());
    for (auto &el : ans.second.r) {
        cout << el;
    }
    cout << '\n';
}


int main() {
    prep();
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}