#include <bits/stdc++.h>
using namespace std;
using vl = __int128;
using ll = long long;
using pii = pair<ll, ll>;
const ll MAXN = 1e3;
const ll MAXC = 1e18;
const ll INF = 1e18 + 10;


ll n, m;
vector<ll> a, c;
vector<vector<ll>> g;


void gfs(ll v, ll p = -1) {
    ll mx = 0;
    for (auto &u : g[v]) {
        if (u == p) continue;
        gfs(u, v);
        mx = max(mx, a[u]);
    }
    c[v] += mx;
    a[v] += mx * (ll)g[v].size();

    for (auto &u : g[v]) {
        if (u == p) continue;

        a[u] -= mx;
    }
    if (p != -1) {
        a[p] -= mx;
    }
}

vector<ll> nd;
void prep(ll v, ll p = -1) {
    nd[v] = -a[v];
    for (auto &u : g[v]) {
        if (u == p) continue;
        prep(u, v);

        nd[v] += nd[u];
    }
}

void dfs(ll v, ll p = -1) {
    if (p != -1) {
        vector<ll> son;
        for (auto &u : g[v]) {
            if (u == p) continue;
            son.push_back(u);
        }
        c[v] += nd[v];
        a[v] += nd[v] * (ll)g[v].size();
        a[p] -= nd[v];
        for (auto &u : son) {
            a[u] -= nd[v];
            nd[u] += nd[v];
        }
    }
    for (auto &u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
    }
    //if (a[v] < 0) throw(0);
}


void solve() {
    cin >> n >> m;
    ll all_s = 0;
    a.assign(n, 0);
    for (auto &el : a) {
        cin >> el;
        all_s += el;
    }
    auto hv = a;
    if (all_s < 0) {
        cout << "Impossible\n";
        return;
    }
    c.assign(n, 0);

    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    gfs(0, -1);
    nd.assign(n, 0);
    prep(0, -1);
    /*for (ll i = 1; i < n; i++) {
        if (nd[i] < 0) throw(0);
    }*/
    dfs(0, -1);

    for (ll i = 0; i < n; i++) {
        hv[i] += c[i] * (ll)g[i].size();
        for (auto &u : g[i]) {
            hv[u] -= c[i];
        }
    }
    if (hv != a) throw(0);
    for (auto &el : hv) {
        if (el < 0) {
            cout << "Impossible\n";
            return;
        }
        /*if (el >= 0) continue;
        if (n < 100) throw(0);
        cout << "Impossible\n";
        return;*/
    }

    cout << "Possible\n";
    for (auto &el : c) {
        //if (el > MAXC || el < 0) throw(0);
        cout << el << ' ';
    }
    cout << '\n';
}


int main() {
    //prep();
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}