#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<iomanip>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
vector<int> resheto(int n) {
	vector<int> primes;
	vector<int> d(n + 1, 0);
	for (int i = 2; i <= n; ++i) {
		if (d[i] == 0) {
			primes.push_back(i);
			d[i] = i;
		}
		for (auto prime : primes) {
			if (prime > d[i] || i * prime > n) break;
			d[prime * i] = prime;
		}
	}
	return primes;
}
void solve() {
	int a, b; cin >> a >> b;
	vector<int> primes = resheto(2 * sqrt(b));
	int ch = a, d = 0;
	for (int i = min((b + 1) / 2, a); i <= b; ++i) {
		int di = 1;
		int j = i;
		for (auto prime : primes) {
			int k = 1;
			while (j % prime == 0) {
				j /= prime; ++k;
			}
			di *= k;
		}
		if (di > d) {
			ch = i, d = di;
		}
	}
	cout << ch;
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//precalc();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}