#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<iomanip>
#include<chrono>

using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
vector<int> resheto(int n) {
	vector<int> primes;
	vector<int> d(500); 
	int p = 1;
	for (int i = 2; ; ++i) {
		if (d[i] == 0) {
			primes.push_back(i);
			d[i] = i;
			p *= i;
			if (p > n) return primes;
		}
		for (auto prime : primes) {
			if (prime > d[i] || i * prime > n) break;
			if(prime * i < d.size()) d[prime * i] = prime;
		}
	}
	return primes;
}
void solve() {
	int a, b; cin >> a >> b;
	auto time = chrono::high_resolution_clock::now();
	vector<int> primes = resheto(b);
	int ch = a, d = 0;
	for (int i = b; i >= max(b/2, a); --i) {
		chrono::duration<double, milli> need = chrono::high_resolution_clock::now() - time;
		if (need.count() > 95) break;
		int di = 1;
		int j = i;
		for (auto prime : primes) {
			int k = 1;
			while (j % prime == 0) {
				j /= prime; ++k;
			}
			di *= k;
		}
		if (di > d) {
			ch = i, d = di;
		}
	}
	cout << ch;
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//precalc();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}