#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<iomanip>
#include<functional>
#include<numeric>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmax(a, b) a = max(a, b)
#define chmin(a, b) a = min(a, b)
const int N = 1e5;
vector<int> g[N];
vector<int> c, ans;
int sm[N];
void dfs(int v, int par) {
	int mx = 0;
	for (auto u : g[v]) {
		if (u == par) continue;
		dfs(u, v);
		chmax(mx, c[u]);
	}
	ans[v] += mx; c[v] += mx * (g[v].size());
	if (v) {
		c[par] -= mx;
	}
	for (auto u : g[v]) {
		if (u == par) continue;
		c[u] -= mx;
	}	
}
void dfs1(int v, int par) {
	sm[v] = c[v];
	for (auto u : g[v]) {
		if (u == par) continue;
		dfs1(u, v);
		sm[v] += sm[u];
	}
}
void dfs2(int v, int par) {
	ans[v] -= sm[v];
	c[par] += sm[v];
	c[v] -= g[v].size() * sm[v];
	for (auto u : g[v]) {
		if (u == par) continue;
		c[u] += sm[v];
		sm[u] += sm[v];
	}
	sm[v] = 0;
	for (auto u : g[v]) {
		if (u == par) continue;
		dfs2(u, v);
	}
}
void solve() {
	int n, m; cin >> n >> m;
	c.resize(n); cin(c);
	ans.resize(n);
	int hd = 0;
	for (int i = 0; i < m; ++i) {
		int a, b; cin >> a >> b; --a; --b;
		g[a].push_back(b); g[b].push_back(a);
	}
	if (accumulate(all(c), 0ll) < 0) {
		cout << "Impossible"; return;
	}
	dfs1(0, 0);
	ans[0] += 1e12;
	c[0] += 1e12;
	for (auto u : g[0]) {
		c[u] -= 1e12; sm[u] -= 1e12;
	}

	for (auto u : g[0]) dfs2(u, 0);
	
	/*
	for (int i = n - 2; i >= 0; --i) {
		if (c[i + 1] > 0) {
			ans[i] += c[i + 1];
			c[i] += c[i + 1] * 2;
			if (i) c[i - 1] -= c[i + 1];
			else c[i] -= c[i + 1];
			c[i + 1] = 0;
		}
	}
	for (int i = 1; i < n; ++i) {
		ans[i] += c[i - 1];
		c[i] += c[i - 1] * 2;
		if (i + 1 < n) c[i + 1] -= c[i - 1];
		else c[i] -= c[i - 1];
		c[i - 1] = 0;
	}*/
	cout << "Possible\n";
	print(ans, " "); 
	
}
int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//precalc();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

