#include <bits/stdc++.h>

using namespace std;
int n;
vector<int> tr, eu, l, r, d, c;
vector<vector<int>> g;
void push(int i, int l, int r) {
    int m = (l + r) / 2;
    tr[i * 2 + 1] += (m - l) * d[i];
    tr[i * 2 + 2] += (r - m) * d[i];
    d[i * 2 + 1] += d[i];
    d[i * 2 + 2] += d[i];
    d[i] = 0;
}
void add(int i, int l, int r, int ql, int qr, int x) {
    if (ql <= l && r <= qr) {
        d[i] += x;
        tr[i] += x * (r - l);
        return;
    }
    if (r <= ql || qr <= l) {
        return;
    }
    push(i, l, r);
    int m = (l + r) / 2;
    add(i * 2 + 1, l, m, ql, qr, x);
    add(i * 2 + 2, m, r, ql, qr, x);
}
int get(int i, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tr[i];
    }
    if (r <= ql || qr <= l) {
        return 0;
    }
    push(i, l, r);
    int m = (l + r) / 2;
    return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
}
void dfs1(int v, int p) {
    l[v] = eu.size();
    eu.push_back(v);
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs1(u, v);
    }
    r[v] = eu.size();
}
void dfs(int v, int p) {
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        c[v] += c[u];
        add(0, 0, n, l[u], r[u], -c[u]);
        if (c[u] > 0) {
            add(0, 0, n, 0, n, c[u]);
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    int m;
    cin >> m;
    c.resize(n);
    g.resize(n);
    tr.resize(n * 4);
    d.resize(n * 4);
    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        g[b].push_back(a);
    }
    dfs1(0, -1);
    dfs(0, -1);
    if (c[0] < 0) {
        cout << "Impossible\n";
        return 0;
    }
    cout << "Possible\n";
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[eu[i]] = get(0, 0, n, i, i + 1);
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}
