#include <bits/stdc++.h>

using namespace std;
long long n;
vector<long long> tr, eu, l, r, d, c, cicle;
vector<vector<long long>> g;
void push(long long i, long long l, long long r) {
    long long m = (l + r) / 2;
    tr[i * 2 + 1] += (m - l) * d[i];
    tr[i * 2 + 2] += (r - m) * d[i];
    d[i * 2 + 1] += d[i];
    d[i * 2 + 2] += d[i];
    d[i] = 0;
}
void add(long long i, long long l, long long r, long long ql, long long qr, long long x) {
    if (ql <= l && r <= qr) {
        d[i] += x;
        tr[i] += x * (r - l);
        return;
    }
    if (r <= ql || qr <= l) {
        return;
    }
    push(i, l, r);
    long long m = (l + r) / 2;
    add(i * 2 + 1, l, m, ql, qr, x);
    add(i * 2 + 2, m, r, ql, qr, x);
}
long long get(long long i, long long l, long long r, long long ql, long long qr) {
    if (ql <= l && r <= qr) {
        return tr[i];
    }
    if (r <= ql || qr <= l) {
        return 0;
    }
    push(i, l, r);
    long long m = (l + r) / 2;
    return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
}
int type = 0, s;
vector<int> used;
void dfs2(long long v, long long p) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }
        if (used[u] == 0) {
            dfs2(u, v);
            if (type == 2) break;
            if (type == 1) {
                cicle.push_back(v);
                if (v == s) {
                    type = 2;
                }
                break;
            }
        } else if (used[u] == 1) {
            cicle.push_back(v);
            s = u;
            type = 1;
            break;
        }
    }
}
int num;
void dfs1(long long v, long long p) {
    l[v] = eu.size();
    eu.push_back(v);
    for (auto u : g[v]) {
        if (u == p) continue;
        if (p == -1 && cicle.size() > 0) {
            if (u == cicle[(num + 1) % cicle.size()] || u == cicle[(num + cicle.size() - 1) % cicle.size()]) continue;
        }
        dfs1(u, v);
    }
    r[v] = eu.size();
}
void dfs(long long v, long long p) {
    for (auto u : g[v]) {
        if (u == p) continue;
        if (p == -1 && cicle.size() > 0) {
            if (u == cicle[(num + 1) % cicle.size()] || u == cicle[(num + cicle.size() - 1) % cicle.size()]) continue;
        }
        dfs(u, v);
        c[v] += c[u];
        add(0, 0, n, l[u], r[u], -c[u]);
        if (c[u] > 0) {
            add(0, 0, n, 0, n, c[u]);
        }
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    long long m;
    cin >> m;
    c.resize(n);
    g.resize(n);
    tr.resize(n * 4);
    d.resize(n * 4);
    l.resize(n);
    r.resize(n);
    for (long long i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (long long i = 0; i < m; ++i) {
        long long a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        g[b].push_back(a);
    }
    if (m == n - 1) {
        dfs1(0, -1);
        dfs(0, -1);
        if (c[0] < 0) {
            cout << "Impossible\n";
            return 0;
        }
        cout << "Possible\n";
        vector<long long> ans(n);
        long long mi = 1e18;
        for (long long i = 0; i < n; ++i) {
            mi = min(mi, get(0, 0, n, i, i + 1));
        }
        add(0, 0, n, 0, n, -mi);
        for (long long i = 0; i < n; ++i) {
            ans[eu[i]] = get(0, 0, n, i, i + 1);
        }
        for (long long i = 0; i < n; ++i) {
            cout << ans[i] << ' ';
        }
        cout << '\n';
        return 0;
    }
    used.resize(n, 0);
    dfs2(0, n);
    for (int i = 0; i < cicle.size(); ++i) {
        num = i;
        dfs1(cicle[i], -1);
        dfs(cicle[i], -1);
        cout << cicle[i] << " " << c[cicle[i]] << '\n';
    }
    for (int cnt = 0; cnt < n; ++cnt) {
        for (int i = 0; i < cicle.size(); ++i) {
            if (c[cicle[i]] < 0) {
                int x = (1ll - c[cicle[i]]) / 2;
                c[cicle[i]] += x * 2;
                c[cicle[(i + 1) % cicle.size()]] -= x;
                c[cicle[(i + cicle.size() - 1) % cicle.size()]] -= x;
                add(0, 0, n, l[cicle[i]], r[cicle[i]], x);
            } else {
                int x = c[cicle[i]] / 2;
                c[cicle[i]] -= x * 2;
                c[cicle[(i + 1) % cicle.size()]] += x;
                c[cicle[(i + cicle.size() - 1) % cicle.size()]] += x;
                add(0, 0, n, l[cicle[i]], r[cicle[i]], -x);
                add(0, 0, n, 0, n, x);
            }
        }
    }
    for (int i = 0; i < cicle.size(); ++i) {
        if (c[cicle[i]] < 0) {
            cout << "Impossible\n";
            return 0;
        }
    }
    vector<long long> ans(n);
    long long mi = 1e18;
    for (long long i = 0; i < n; ++i) {
        mi = min(mi, get(0, 0, n, i, i + 1));
    }
    add(0, 0, n, 0, n, -mi);
    for (long long i = 0; i < n; ++i) {
        ans[eu[i]] = get(0, 0, n, i, i + 1);
    }
    cout << "Possible\n";
    for (long long i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}
