#include <stdio.h>
#include <numeric>

using ll = long long;
const int BULAN = 35;

ll lcm[BULAN + 1];

ll solve(ll a, ll b) {
  int st = 0;
  int dr = BULAN;
  while(dr - st > 1) {
    int mij = (st + dr) / 2;
    if(lcm[mij] >= a) {
      dr = mij;
    } else {
      st = mij;
    }
  }

  ll x = lcm[dr];
  if(x <= b) {
    return x;
  } else {
    x = lcm[dr - 1];
    return x * solve(a / x, b / x);
  }
}

int main() {
  lcm[0] = 1;
  for(int i = 1; i <= BULAN; i++) {
    lcm[i] = std::lcm(lcm[i - 1], i);
  }

  ll a, b;
  scanf("%lld%lld", &a, &b);
  printf("%lld\n", solve(a, b));

  return 0;
}