#include <stdio.h>
#include <numeric>

using ll = long long;
const int BULAN = 35;

ll lcm[BULAN + 1];

ll solve(ll a, ll b) {
  int st = 1;
  int dr = BULAN + 1;
  while(dr - st > 1) {
    int mij = (st + dr) / 2;
    if(lcm[mij] <= b) {
      st = mij;
    } else {
      dr = mij;
    }
  }

  ll x = lcm[st];
  if(x >= a) {
    return x;
  } else {
    return x * solve(a / x, b / x);
  }
}

int main() {
  lcm[0] = 1;
  for(int i = 1; i <= BULAN; i++) {
    lcm[i] = std::lcm(lcm[i - 1], i);
  }

  ll a, b;
  scanf("%lld%lld", &a, &b);
  ll res = solve(a, b);
  printf("%lld\n", res);

  /*
  ll d = 2;
  while(d * d <= res && res > 1) {
    int cnt = 0;
    while(res % d == 0) {
      res /= d;
      cnt++;
    }
    if(cnt > 0) {
      printf("%lld %d\n", d, cnt);
    }
    d++;
  }
  if(res > 1) {
    printf("%lld 1\n", res, 1);
  }
  */

  return 0;
}