#include <stdio.h>
#include <numeric>

using ll = long long;
const int BULAN = 35;

ll lcm[BULAN + 1];

int main() {
  ll a, b;
  scanf("%lld%lld", &a, &b);

  lcm[0] = 1;
  for(int i = 1; i <= BULAN; i++) {
    lcm[i] = std::lcm(lcm[i - 1], i);
  }

  int st = 1;
  int dr = BULAN + 1;
  while(dr - st > 1) {
    int mij = (st + dr) / 2;
    if(lcm[mij] <= b) {
      st = mij;
    } else {
      dr = mij;
    }
  }

  ll x = lcm[st];
  if(x >= a) {
    printf("%lld\n", x);
  } else {
    int cnt = 2;
    while(x < a) {
      x *= cnt;
      if(x > b) {
        x /= cnt;
        cnt = 2;
        x *= cnt;
      }
      cnt++;
    }
    while(x < a) {
      x *= 2;
    }
    printf("%lld\n", x);
  }

  return 0;
}