#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <chrono>
#include <random>
#include <cmath>
#include <vector>
#include <map>
#include <set>

#define endl '\n'

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
ull l,r;
bool isprime(ull x)
{
    if(x==1||x==0)return 0;
    int sqr=sqrt(x);
    if(sqr*sqr==x)return 0;
    for(int i=2;i<=sqr;i++)
    {
        if(x%i==0)
            return 0;
    }
    return 1;
}
vector <int> p;
void fill_p()
{
    for(int i=2;i<=10000;i++)
    {
        if(isprime(i))
        {
            p.push_back(i);
        }
    }
}
int main()
{
    speed();
    cin>>l>>r;
    fill_p();
    int num=1;
    int pos=0;
    while(num<=r)
    {
        if(num*2>r)break;
        if(p[pos]*num>r)
        {
            pos=0;
        }
        else
        {
            num*=p[pos];
            pos++;
        }
    }
    if(num>=l&&num<=r)
    {
        cout<<num<<endl;
    }
    else
    {
        random_device rd;
        mt19937 rng(rd());
        uniform_int_distribution <ull> d(l,r);
        cout<<d(rng)<<endl;
    }
    return 0;
}
