#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <chrono>
#include <random>
#include <cmath>
#include <vector>
#include <map>
#include <set>

#define endl '\n'

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
ull l,r;
bool isprime(ull x)
{
    if(x==1||x==0)return 0;
    int sqr=sqrt(x);
    if(sqr*sqr==x)return 0;
    for(int i=2;i<=sqr;i++)
    {
        if(x%i==0)
            return 0;
    }
    return 1;
}
vector <int> p;
void fill_p()
{
    for(int i=2;i<=10000;i++)
    {
        if(isprime(i))
        {
            p.push_back(i);
        }
    }
}
vector<int>v[1010000];
int e[1010000];
void reshe()
{
    e[1]=1;
    for(int i=2;i<=r;i++)
    {
        if(e[i])continue;
        v[i].push_back(i);
        for(int j=i*2;j<=r;j+=i)
        {
            e[j]=1;
            v[j].push_back(i);
        }
    }
}
int raz(int x)
{
    if(x==1)return 1;
    long long num=1;
    int d=0;
    int num2=0;
    int cx=x;
    while(x!=1)
    {
        int del=v[cx][d];
        if(x%del==0)
        {
            num2=1;
            while(x%del==0)
            {
                x/=del;
                num2++;
            }
            num*=num2;
        }
        d++;
        if(v[cx].size()<=d)break;
    }
    return num;
}
int main()
{
    speed();
    cin>>l>>r;
    fill_p();
    int num=1;
    int pos=0;
    bool lamp=0;
    while(num<=r)
    {
        if(num*2>r)break;
        if(p[pos]*num>r)
        {
            pos=0;
        }
        else
        {
            num*=p[pos];
            pos++;
        }
    }
    if(num>=l&&num<=r)
    {
        cout<<num<<endl;
    }
    else
    {
        random_device rd;
        mt19937 rng(rd());
        uniform_int_distribution <ull> d(l,r);
        if(r>1000000)cout<<d(rng)<<endl;
        int ma=0;
        int mn;
        reshe();
        for(int i=l;i<=r;i++)
        {
            int x=raz(i);
            //cout<<i<<" "<<x<<endl;
            if(x>ma)
            {
                ma=x;
                mn=i;
            }
        }
        cout<<mn<<endl;
    }
    return 0;
}
