#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <chrono>
#include <random>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include "tunnels.h"


typedef long long ll;
typedef unsigned long long ull;
using namespace std;

void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    if(m==2)
    {
        int tl=0;
        int t=k;
        while(tl<n)
        {
            if(blocked[tl][0]==0&&blocked[tl][1]==1)
            {
                goDeeper(0);
                t=0;
            }
            else if(blocked[tl][0]==1&&blocked[tl][1]==0)
            {
                goDeeper(1);
                t=1;
            }
            else if(tl<n-1)
            {
                if(blocked[tl+1][0]==1&&blocked[tl+1][1]==0){goDeeper(1);t=1;}
                else if(blocked[tl+1][0]==0&&blocked[tl+1][1]==1){goDeeper(0);t=0;}
                else if(t==0)
                {
                    if(investigate(1))
                    {
                        goDeeper(1);
                        t=1;
                    }
                    else
                    {
                        goDeeper(0);
                        t=0;
                    }
                }
                else if(t==1)
                {
                    if(investigate(0))
                    {
                        goDeeper(0);
                        t=0;
                    }
                    else
                    {
                        goDeeper(1);
                        t=1;
                    }
                }
            }
            else
            {
                if(t==1)
                {if(investigate(0))goDeeper(0);
                else goDeeper(1);}
                else
                {
                    if(investigate(1))goDeeper(1);
                    else goDeeper(0);
                }
            }
            tl++;
        }
    }
    else
    {
        int t=k;
        int p=0;
        int tl=0;
        while(tl<n)
        {
            if(t==m-1)
            {
                int l=0,r=m-1;
                while(l<=r)
                {
                    int mid=(l+r)/2;
                    if(investigate(mid))
                    {
                        r=mid-1;
                    }
                    else l=mid+1;
                }
                if(investigate(l-1))
                   {
                       goDeeper(l-1);
                       t=l-1;
                   }
                else if(investigate(l))
                    {
                       goDeeper(l);
                       t=l;
                   }
                else if(investigate(l+1))
                {
                       goDeeper(l+1);
                       t=l+1;
                   }
            }
            else if(t==0)
            {
                int l=0,r=m-1;
                while(l<=r)
                {
                    int mid=(l+r)/2;
                    if(investigate(mid))
                    {
                        r=mid-1;
                    }
                    else l=mid+1;
                }
                if(investigate(l+1)){
                       goDeeper(l+1);
                       t=l+1;
                   }
                else if(investigate(l)){
                       goDeeper(l);
                       t=l;
                   }
                else if(investigate(l-1)){
                       goDeeper(l-1);
                       t=l-1;
                   }
            }
            else if(investigate(t-1))
            {
                int l=0,r=t;
                while(l<=r)
                {
                    int mid=(l+r)/2;
                    if(investigate(mid))
                    {
                        r=mid-1;
                    }
                    else l=mid+1;
                }
                if(investigate(l+1)){
                       goDeeper(l+1);
                       t=l+1;
                   }
                else if(investigate(l)){
                       goDeeper(l);
                       t=l;
                   }
                else if(investigate(l-1)){
                       goDeeper(l-1);
                       t=l-1;
                   }
            }
            else if(investigate(t+1))
            {
                int l=t,r=m-1;
                while(l<=r)
                {
                    int mid=(l+r)/2;
                    if(investigate(mid))
                    {
                        r=mid-1;
                    }
                    else l=mid+1;
                }
                if(investigate(l+1)){goDeeper(l+1);t=l+1;}
                else if(investigate(l)){goDeeper(l);t=l;}
                else if(investigate(l-1)){goDeeper(l-1);t=l-1;}
            }
        }
    }
}
