#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked) {
    int cur = k;
    goDeeper(k);
    for (auto x : blocked) {
        for (auto y : x) cout << y << " ";
        cout << endl;
    }
    for (int level = 0; level < n - 1; level++) {
        int l = cur;
        bool f = false;
        while (l >= 0 && !blocked[level][l]) {
            if (!blocked[level + 1][l] && investigate(l)) {
                goDeeper(l);
                cur = l;
                f = true;
                cout << l << endl;
            }
            l--;
        }
        if (f) continue;
        int r = cur + 1;
        while (r < m && !blocked[level][r]) {
            if (!blocked[level + 1][r] && investigate(r)) {
                goDeeper(r);
                cur = r;
            }
            r++;
        }
    }
}
