#include<bits/stdc++.h>
#define endl '\n'
#define ll __int128

using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}

std::ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs ;
    return out;
}

const ll MAXN = 2e6;

ll a,b;
long long ans=0,cnt=0;
long long m[MAXN+5];

void solve()
{
    for(int i=a;i<=b;i++)
    {
        int add = 2;
        if(i==1)add--;
        if(m[i] + add>cnt){
            cnt = m[i];
            ans = i;
        }
    }
    cout<<ans<<endl;
}

ll countDivisors(ll n)
{
    if(n==1)return 1;
    ll br = 1,cnt=0;
    for(ll i=2 ; i*i<=n;i++)
    {
        cnt = 0;
        while(n%i==0){
            cnt++;
            n/=i;
        }
        br *= (cnt+1);
    }
    if(n!=1)  {
        br *= 2;
    }
    return br;
}

void sieve()
{
    for(ll i=2;i<=MAXN;i++)
    {
        for(ll j = i + i; j<=MAXN;j+=i){
            m[j]++;
        }
    }
}

void input()
{
    cin>>a>>b;
}

void fastIATI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    fastIATI();
    input();
    if(b<=pow(2,20))
    {
        sieve();
        solve();
        return 0;
    }
    cout<<a<<endl;
    return 0;
}
