#include "tunnels.h"
#include <bits/stdc++.h>
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int l=0,u=k;
    while(l<n-1)
    {
        //std::cout<<-1<<std::endl;
        std::vector<int>left;
        std::vector<int>right;
        int t=u-1;
        while(t>=0 && !blocked[l][t])
        {
            if(!blocked[l+1][t])
            {
                left.push_back(t);
            }
            t--;
        }
        //std::cout<<0<<std::endl;
        t=u+1;
        while(t<m && !blocked[l][t])
        {
            if(!blocked[l+1][t])
            {
                right.push_back(t);
            }
            t++;
        }
        //std::cout<<1<<std::endl;
        int ind=u;
        for(int i=0; i<left.size(); i++)
        {
            if(investigate(left[i]))
            {
                ind=left[i];
            }
            else
            {
                break;
            }
        }
        if(ind==u)
        {
            for(int i=0; i<right.size(); i++)
            {
                if(investigate(right[i]))
                {
                    ind=right[i];
                }
                else
                {
                    break;
                }
            }
        }
        goDeeper(ind);
        l++;
    }
    int i,j;
    for(i=u;i<m;i++)
    {
        if(blocked[l][i])
        {
            i--;
            break;
        }
    }
    for(j=u;j>=0;j--)
    {
        if(blocked[l][j])
        {
            j++;
            break;
        }
    }
    if(i==u && j==u)goDeeper(u);
    else if(i==u)
    {
        i--;
        for(;i>=j;i--)
        {
            if(!investigate(i))
            {
                goDeeper(i+1);
            }
        }
    }
    else if(j==u)
    {
        j++;
        for(;j<=i;j++)
        {
            if(!investigate(j))
            {
                goDeeper(j-1);
            }
        }
    }
}