#include "tunnels.h"
#include <bits/stdc++.h>
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    int l=0,u=k;
    while(l<n-1)
    {
        //std::cout<<-1<<std::endl;
        std::vector<int>left;
        std::vector<int>right;
        int t=u-1;
        while(t>=0 && !blocked[l][t])
        {
            if(!blocked[l+1][t])
            {
                left.push_back(t);
            }
            t--;
        }
        //std::cout<<0<<std::endl;
        t=u+1;
        while(t<m && !blocked[l][t])
        {
            if(!blocked[l+1][t])
            {
                right.push_back(t);
            }
            t++;
        }
        //std::cout<<1<<std::endl;
        if(left.empty() && right.empty())
        {
            goDeeper(u);
            l++;
        }
        else
        {
            int ind=u;
            int x=0;
            if(right.empty())
            {
                x=1;
                ind=left[0];
            }
            for(int i=x; i<left.size(); i++)
            {
                if(investigate(left[i]))
                {
                    ind=left[i];
                }
                else
                {
                    break;
                }
            }
            if(ind==u)
            {
                int x=0;
                if(blocked[l+1][u])
                {
                    x=1;
                    ind=right[0];
                }
                for(int i=x; i<right.size(); i++)
                {
                    if(investigate(right[i]))
                    {
                        ind=right[i];
                    }
                    else
                    {
                        break;
                    }
                }
            }
            goDeeper(ind);
            l++;
            u=ind;
        }
    }
    int i,j;
    for(i=u+1; i<m; i++)
    {
        if(blocked[l][i])
        {
            break;
        }
    }
    for(j=u; j>=0; j--)
    {
        if(blocked[l][j])
        {
            break;
        }
    }
    i--;
    j++;
    std::cout<<i<<' '<<j<<std::endl;
    if(i==u && j==u)goDeeper(u);
    else if(i==u)
    {
        i--;
        for(; i>=j; i--)
        {
            if(!investigate(i))
            {
                goDeeper(i+1);
            }
            else if(i==j)
            {
                goDeeper(i);
            }
        }
    }
    else if(j==u)
    {
        j++;
        for(; j<=i; j++)
        {
            if(!investigate(j))
            {
                goDeeper(j-1);
            }
            else if(j==i)
            {
                goDeeper(j);
            }
        }
    }
}