#include <bits/stdc++.h>
using namespace std;

const int MAXN=2^20;

int a, b;

bool r[MAXN];
int npd[MAXN];

int brdel(int n)
{
    unordered_map<int, int> m;
    while(n!=1)
    {
        m[npd[n]]++;
        n/=npd[n];
    }
    int ans=1;
    for(const auto& x:m)
    {
        ans*=x.second+1;
    }
    return ans;
}

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void input()
{
    cin >> a >> b;
}

void solve()
{
    r[0]=1;
    r[1]=1;
    for(int i=2; i<MAXN; i++)
    {
        if(!r[i])
        {
            npd[i]=i;
            for(int j=2*i; j<MAXN; j+=i)
            {
                r[j]=1;
                if(npd[j]==0)
                {
                    npd[j]=i;
                }
            }
        }
    }
    int ans=a, m=0;
    for(int i=a; i<=b; i++)
    {
        int q=brdel(i);
        if(q>m)
        {
            m=q;
            ans=i;
        }
    }
    cout << ans << endl;
}

int main ()
{
    fastIO();
    input();
    solve();
    return 0;
}

