#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const vector <vector <bool>>& blocked) {
    vector <vector <int>> block(n);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (blocked[i][j]) block[i].push_back(j);
        }
    }

    int cell = k;

    for (int i = 0; i < n; i++) {
        if (cell > 0 && !blocked[i][cell - 1] && investigate(cell - 1)) {
            auto it = lower_bound(block[i].begin(), block[i].end(), cell);
            int l;

            if (it == block[i].begin()) l = 0;
            else l = *(--it) + 1;

            int r = cell - 1, ans = cell - 1;

            while (l < r) {
                int m = (l + r) / 2;

                if (investigate(m)) {
                    ans = m;
                    r = m - 1;
                } else l = m + 1;
            }

            cell = ans;
            goDeeper(cell);
            continue;
        }

        if (cell + 1 < m && !blocked[i][cell + 1] && investigate(cell + 1)) {
            int l = cell + 1, ans = cell + 1;
            int r;

            auto it = lower_bound(block[i].begin(), block[i].end(), cell);
            if (it == block[i].end()) r = m - 1;
            else r = (*it) + 1;

            while (l < r) {
                int m = (l + r) / 2;

                if (investigate(m)) {
                    ans = m;
                    l = m + 1;
                } else r = m - 1;
            }

            cell = ans;
            goDeeper(cell);
            continue;
        }

        goDeeper(cell);
    }
}
