#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

void solve(int n, int m, int k, const vector <vector <bool>>& blocked) {
    int cell = k;

    for (int i = 0; i < n; i++) {
        int left_ptr = cell - 1;

        while (left_ptr > 0 && !blocked[i][left_ptr - 1] && investigate(left_ptr - 1)) {
            left_ptr--;
        }

        if (left_ptr != cell) {
            cell = left_ptr;
            goDeeper(left_ptr);
            continue;
        }

        int right_ptr = cell - 1;

        while (right_ptr + 1 < n && !blocked[i][right_ptr + 1] && investigate(right_ptr + 1)) {
            right_ptr++;
        }

        cell = right_ptr;
        goDeeper(right_ptr);
    }
}
