#include <bits/stdc++.h>
#include "tunnels.h"
using namespace std;

bool ask(int n, int m, int cell, int q) {

}

void solve(int n, int m, int k, const vector <vector <bool>>& blocked) {
    vector <vector <int>> block(n);
    vector <int> not_blocked;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (blocked[i][j]) block[i].push_back(j);
        }
    }

    int cell = k;

    for (int i = 0; i < n; i++) {
        int ptr = cell;
        while (ptr > 0 && !blocked[i][ptr - 1]) {
            ptr--;
        }

        vector <int> available_cells;

        if (i + 1 == n || !blocked[i + 1][ptr]) available_cells.push_back(ptr);

        while (ptr + 1 < m && !blocked[i][ptr + 1]) {
            ptr++;
            if (i + 1 == n || !blocked[i + 1][ptr]) available_cells.push_back(ptr);
        }

        auto it = lower_bound(available_cells.begin(), available_cells.end(), cell);

        if (it != available_cells.begin() && investigate(*(--it))) {
            int l = 0, r = (int) (it - available_cells.begin()) - 1, ans = *it;

            while (l <= r) {
                int m = (l + r) / 2;

                if (investigate(available_cells[m])) {
                    ans = available_cells[m];
                    r = m - 1;
                } else l = m + 1;
            }

            cell = ans;
            goDeeper(ans);
            continue;
        }

        int l = lower_bound(available_cells.begin(), available_cells.end(), cell) - available_cells.begin() + 1, r = available_cells.size() - 1, ans = cell;

        while (l <= r) {
            int m = (l + r) / 2;

            if (investigate(available_cells[m])) {
                ans = m;
                l = m + 1;
            } else r = m - 1;
        }

        cell = ans;
        goDeeper(ans);
        continue;
    }
}

