#include<bits/stdc++.h>
#include "tunnels.h"
using namespace std;

const int MAXN = 5007;
int pref[MAXN][MAXN], suf[MAXN][MAXN];

int bs(bool right, int i, int k)
{
    if(right)
    {
        int l = k-1, r = k+suf[i][k]+1, mid;
        while(l < r-2)
        {
            mid = (l+r)/2;
            if(investigate(mid)) l = mid;
            else r = mid;
        }
        return (l+r)/2;
    }
    else
    {
        int l = k-pref[i][k]-1, r = k+1, mid;
        while(l < r-2)
        {
            mid = (l+r)/2;
            if(investigate(mid)) r = mid;
            else l = mid;
        }
        return (l+r)/2;
    }
}

void solve(int n, int m, int k, const vector<vector<bool>>& blocked)
{
    for(int i = 0; i < n; i++)
    {
        if(blocked[i][0]) pref[i][0] = -1;
        else pref[i][0] = 0;
        for(int j = 1; j < m; j++)
        {
            if(blocked[i][j]) pref[i][j] = -1;
            else pref[i][j] = pref[i][j-1]+1;
        }
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            cout<<pref[i][j]<<" ";
        }
        cout<<"\n";
    }
    cout<<"\n";
    for(int i = 0; i < n; i++)
    {
        if(blocked[i][m-1]) suf[i][m-1] = -1;
        else suf[i][m-1] = 0;
        for(int j = m-2; j >= 0; j--)
        {
            if(blocked[i][j]) suf[i][j] = -1;
            else suf[i][j] = suf[i][j+1]+1;
        }
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            cout<<suf[i][j]<<" ";
        }
        cout<<"\n";
    }
    int curr = k;
    for(int i = 0; i < n; i++)
    {
        if(pref[i][curr] == 0 && suf[i][curr] == 0)
        {
            goDeeper(curr);
            continue;
        }
        if(pref[i][curr] == 0)
        {
            int ans = bs(true, i, curr);
            goDeeper(ans);
            continue;
        }
        if(suf[i][curr] == 0)
        {
            int ans = bs(false, i, curr);
            goDeeper(ans);
            continue;
        }
        bool t = investigate(curr-1);
        if(t)
        {
            int ans = bs(false, i, curr);
            goDeeper(ans);
            continue;
        }
        else
        {
            int ans = bs(true, i, curr);
            goDeeper(ans);
            continue;
        }
    }
    return;
}
