#include <bits/stdc++.h>
#include "tunnels.h"

using namespace std;

const int N = 5000 + 11;
pair<int, int> reach[N][N];

/// za 21 tochki:
void solve(int n, int m, int k, const std::vector<std::vector<bool>>& blocked)
{
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(blocked[i][j])
            {
                continue;
            }
            reach[i][j] = {j, j};
            for(int k=j+1; k<=m; k++)
            {
                if(k == m || blocked[i][k])
                {
                    reach[i][j].second = k - 1;
                    break;
                }
            }
            for(int k=j-1; k>=-1; k--)
            {
                if(k == -1 || blocked[i][k])
                {
                    reach[i][j].first = k + 1;
                    break;
                }
            }

         ///   cout<<"Coordinates: "<<i<<" "<<j<<": reach = {"<<reach[i][j].first<<", "<<reach[i][j].second<<"}\n";
        }
    }
    int cx = 0, cy = k;
    while(cx < n)
    {
        for(int i=reach[cx][cy].first; i<=reach[cx][cy].second; i ++){
            if(cx < n-1 && blocked[cx + 1][i]){
                continue;
            }
            if(investigate(i)){
                goDeeper(i);
                cx ++;
                cy = i;
                break;
            }
        }
    }
}